Bug 19239 - Including stdlib.h ends up with macros major and minor being defined
Summary: Including stdlib.h ends up with macros major and minor being defined
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: libc (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: 2.28
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-11-13 05:12 IST by Shafik Yaghmour
Modified: 2018-08-01 05:53 IST (History)
5 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Shafik Yaghmour 2015-11-13 05:12:23 IST
Given the following code:

#include <fstream> //or iostream, sstream, istream, ostream

struct A {
  unsigned major;
  unsigned minor;

  A(int major, int minor) :
    major(major), minor(minor){ }
};

int main() {
  A a1(1, 1);

  return 0;
}

which is a reduced example from this Stackoverflow queston: http://stackoverflow.com/q/33681093/1708801

Generates the following diagnostics http://melpon.org/wandbox/permlink/Bex1ymr03yuu44Pd:

prog.cc:8:5: error: member initializer 'gnu_dev_major' does not name a non-static data member or base class
    major(major), minor(minor){ }
    ^~~~~~~~~~~~
/usr/include/x86_64-linux-gnu/sys/sysmacros.h:67:21: note: expanded from macro 'major'
# define major(dev) gnu_dev_major (dev)
                    ^~~~~~~~~~~~~~~~~~~
prog.cc:8:19: error: member initializer 'gnu_dev_minor' does not name a non-static data member or base class
    major(major), minor(minor){ }
                  ^~~~~~~~~~~~
/usr/include/x86_64-linux-gnu/sys/sysmacros.h:68:21: note: expanded from macro 'minor'
# define minor(dev) gnu_dev_minor (dev)
                    ^~~~~~~~~~~~~~~~~~~
2 errors generated.

So it looks like the underlying issue is that various stream related headers bring in stdlib.h which eventually casues sys/sysmacros.h to be be included. The details were identified in one of the comments which said:

_GNU_SOURCE causes stdlib.h to include sys/types.h, and it causes sys/types.h to include sys/sysmacros.h
Comment 1 joseph@codesourcery.com 2015-11-13 10:54:34 IST
I think this is mainly a GCC bug with _GNU_SOURCE being defined by 
default.  See <https://gcc.gnu.org/bugzilla/show_bug.cgi?id=11196>.

Avoiding this _GNU_SOURCE definition is hard, because much of the C++ 
standard library is in the headers and requires functionality outside the 
ISO C library to implement it.  As discussed in 
<https://sourceware.org/ml/libc-alpha/2012-03/msg00311.html>, we'd be 
happy to provide a way for libstdc++ to get exactly the interfaces it 
needs beyond ISO C (at the API and ABI level).  But I don't think we've 
seen further details from the libstdc++ side of exactly what's required.

It may be we could also change the _GNU_SOURCE API so that fewer headers 
result in sys/sysmacros.h being included, but that would need a concrete 
proposal for an API change on libc-alpha; it's not inherently a bug, so 
libc-alpha is the right place (followed by a patch there is the API change 
proposal gets consensus).
Comment 3 Rich Felker 2015-11-13 15:34:40 IST
While I agree that defining _GNU_SOURCE from the gcc side is _a_ bug, I think this is also a glibc bug. Individually having stdlib.h include sys/types.h and having sys/types.h include sys/sysmacros.h both make sense as legacy-compat behaviors, but having stdlib.h expose the junk from sys/sysmacros.h is highly undesirable to the point of being a bug.

Yes, there should be a concrete API proposal for removing implicit includes like this, but I don't think the need for such a proposal negates classifying this as a bug.

My preliminary proposal is that all implicit inclusion of sys/sysmacros.h should be removed. Only a very small number of programs (things like ls, mknod, etc.) have any use at all for these macros and they should be fixed to include it explicitly if they're not already doing so.
Comment 4 cvs-commit@gcc.gnu.org 2016-07-08 17:02:39 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, azanella/deprecate-makedev has been created
        at  58dc3371865ef8e331de33423c57af855f6b6c45 (commit)

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=58dc3371865ef8e331de33423c57af855f6b6c45

commit 58dc3371865ef8e331de33423c57af855f6b6c45
Author: Zack Weinberg <zackw@panix.com>
Date:   Thu Jul 7 17:10:02 2016 -0300

    Deprecate inclusion of <sys/sysmacros.h> by <sys/types.h>
    
    The macros defined by <sys/sysmacros.h> are not part of POSIX nor XSI,
    and their names have been found frequently to collide with user code;
    see for instance glibc bug 19239 and Red Hat bug 130601.  <stdlib.h>
    includes <sys/types.h> under _GNU_SOURCE, and C++ code presently cannot
    avoid being compiled under _GNU_SOURCE, exacerbating the problem.
    
    	* NEWS: Inclusion of <sys/sysmacros.h> by <sys/types.h> is deprecated.
    	* misc/sys/sysmacros.h: If __SYSMACROS_DEPRECATED_INCLUSION is defined,
    	define major, minor, and makedev to issue deprecation warnings on use.
    	If __SYSMACROS_DEPRECATED_INCLUSION is *not* defined, suppress
    	previously-activated deprecation warnings for these macros and prevent
    	subsequent inclusions of this header from having any effect.
    	* posix/sys/types.h: Define __SYSMACROS_DEPRECATED_INCLUSION before
    	including <sys/sysmacros.h>, and undefine it again afterward.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=c304e8024e39c68fdbaa2681855f1e0af0a48659

commit c304e8024e39c68fdbaa2681855f1e0af0a48659
Author: Zack Weinberg <zackw@panix.com>
Date:   Thu Jul 7 17:07:09 2016 -0300

    Add utility macros for clang detection, and deprecation with messages
    
    Add three new macros to features.h and sys/cdefs.h:
    
     * __glibc_clang_prereq: just like __GNUC_PREREQ, but for clang.
     * __glibc_clang_has_extension: wraps clang's intrinsic __has_extension.
       Writing "#if defined __clang__ && __has_extension (...)" doesn't work,
       because compilers other than clang will object to the unknown macro
       __has_extension even though they don't need to evaluate it.
       Instead, write "#if __glibc_clang_has_extension (...)".
    
     * __attribute_deprecated_msg__(msg): like __attribute_deprecated__, but
       if possible, prints a message.
    
    	* include/features.h (__glibc_clang_prereq): New macro.
    	* misc/sys/cdefs.h (__glibc_clang_has_extension)
    	(__attribute_deprecated_msg__): New macros.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=050bc98376edd26429cff885c339c53f30224aa7

commit 050bc98376edd26429cff885c339c53f30224aa7
Author: Zack Weinberg <zackw@panix.com>
Date:   Thu Jul 7 16:00:45 2016 -0300

    Minimize sysdeps code involved in defining major/minor/makedev
    
    Presently sys/sysmacros.h is entirely defined in sysdeps.  This would
    mean that the deprecation logic coming up in patch #4 would have to be
    written twice (in generic/ and unix/sysv/linux/).  To avoid that, hoist
    all but the unavoidably system-dependent logic to misc/, leaving a bits/
    header behind.  This also promotes the Linux-specific encoding of dev_t,
    which accommodated 32-bit major and minor numbers in a 64-bit dev_t,
    to generic, as glibc's dev_t is always 64 bits wide.
    
    The former Linux implementation used inline functions to avoid evaluating
    arguments more than once.  After this change, all platforms use inline
    functions, which means that three new symbols are added to the generic ABI.
    
    New ports henceforth need only provide bits/sysmacros.h defining macros
    __makedev_body, __major_body, and __minor_body.
    
    While I was at it, I added a basic round-trip test for these functions.
    
    Tested on x86_64, i686, x32, aarch64, armhf, powerpc64le, s390x, and
    s390.
    
    	* misc/sys/sysmacros.h: New file with generic inline-function-based
    	implementation of major, minor, makedev, derived from the old
    	sysdeps/unix/sysv/linux/sys/sysmacros.h.
    	* include/sys/sysmacros.h: New wrapper.
    
    	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Move ...
    	* bits/sysmacros.h: ... here; only define __makedev_body,
    	__major_body, __minor_body.
    	* sysdeps/generic/sys/sysmacros.h: Deleted.
    
    	* sysdeps/unix/sysv/linux/makedev.c: Move ...
    	* misc/makedev.c: ... here; make generic.
    	* misc/tst-makedev.c: New test.
    
    	* misc/Makefile (headers): Add sys/sysmacros.h, bits/sysmacros.h.
    	(routines): Add makedev.
    	(tests): Add tst-makedev.
    	* misc/Versions [GLIBC_2.24]: Add gnu_dev_major, gnu_dev_minor,
    	gnu_dev_makedev.
    	* posix/Makefile (headers): Remove sys/sysmacros.h.
    	* sysdeps/unix/sysv/linux/Makefile (sysdep_routines): Remove makedev.
    
    	* sysdeps/arm/nacl/libc.abilist: Add GLIBC_2.24,
    	gnu_dev_major, gnu_dev_makedev, gnu_dev_minor.

-----------------------------------------------------------------------
Comment 5 cvs-commit@gcc.gnu.org 2016-08-03 20:04:22 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  dbab6577c6684c62bd2521c1c29dc25c3cac966f (commit)
       via  63eb8df85a17f7f966d4daa4cf44c8e956636a86 (commit)
       via  cab4d74b01320670f57dcf356ff89256f4d2fc12 (commit)
      from  bf91be88ea90c1ea888d5646270d66363389ce96 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=dbab6577c6684c62bd2521c1c29dc25c3cac966f

commit dbab6577c6684c62bd2521c1c29dc25c3cac966f
Author: Zack Weinberg <zackw@panix.com>
Date:   Tue May 10 11:07:42 2016 -0400

    Deprecate inclusion of <sys/sysmacros.h> by <sys/types.h>
    
    The macros defined by <sys/sysmacros.h> are not part of POSIX nor XSI, and
    their names frequently collide with user code; see for instance glibc bug
    19239 and Red Hat bug 130601.  <stdlib.h> includes <sys/types.h> under
    _GNU_SOURCE, and C++ code presently cannot avoid being compiled under
    _GNU_SOURCE, exacerbating the problem.
    
    	* NEWS: Inclusion of <sys/sysmacros.h> by <sys/types.h> is deprecated.
    	* misc/sys/sysmacros.h: If __SYSMACROS_DEPRECATED_INCLUSION is defined,
    	define major, minor, and makedev to issue deprecation warnings on use.
    	If __SYSMACROS_DEPRECATED_INCLUSION is *not* defined, suppress
    	previously-activated deprecation warnings for these macros and prevent
    	subsequent inclusions of this header from having any effect.
    	* posix/sys/types.h: Define __SYSMACROS_DEPRECATED_INCLUSION before
    	including <sys/sysmacros.h>, and undefine it again afterward.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=63eb8df85a17f7f966d4daa4cf44c8e956636a86

commit 63eb8df85a17f7f966d4daa4cf44c8e956636a86
Author: Zack Weinberg <zackw@panix.com>
Date:   Thu Apr 28 12:29:55 2016 -0400

    Minimize sysdeps code involved in defining major/minor/makedev.
    
    Presently sys/sysmacros.h is entirely defined in sysdeps.  This would
    mean that the deprecation logic coming up in the next patch would have
    to be written twice (in generic/ and unix/sysv/linux/).  To avoid that,
    hoist all but the unavoidably system-dependent logic to misc/, leaving a
    bits/ header behind.  This also promotes the Linux-specific encoding of
    dev_t, which accommodates 32-bit major and minor numbers in a 64-bit dev_t,
    to generic, as glibc's dev_t is always 64 bits wide.
    
    The former Linux implementation used inline functions to avoid evaluating
    arguments more than once.  After this change, all platforms use inline
    functions, which means that three new symbols are added to the generic ABI.
    (These symbols are in the user namespace, which is how they have always
    been on Linux.  They begin with "gnu_dev_", so collisions with user code
    are pretty unlikely.)
    
    New ports henceforth need only provide a bits/sysmacros.h defining
    internal macros __SYSMACROS_{DECLARE,DEFINE}_{MAJOR,MINOR,MAKEDEV}.
    This is only necessary if the kernel encoding is incompatible with
    the now-generic encoding (for instance, it would be necessary for
    FreeBSD).
    
    While I was at it, I added a basic round-trip test for these functions.
    
    	* sysdeps/generic/sys/sysmacros.h: Delete file.
    	* sysdeps/unix/sysv/linux/makedev.c: Delete file.
    	* sysdeps/unix/sysv/linux/sys/sysmacros.h: Move file ...
    	* bits/sysmacros.h: ... here; this encoding is now the generic
    	encoding.  Now defines only the following macros:
    	__SYSMACROS_DECLARE_MAJOR, __SYSMACROS_DEFINE_MAJOR,
    	__SYSMACROS_DECLARE_MINOR, __SYSMACROS_DEFINE_MINOR,
    	__SYSMACROS_DECLARE_MAKEDEV, __SYSMACROS_DEFINE_MAKEDEV.
    
    	* misc/sys/sysmacros.h, misc/makedev.c: New files that use
    	bits/sysmacros.h and the above new macros to generate the
    	public implementations of major, minor, and makedev.
    	* misc/tst-makedev.c: New test.
    	* include/sys/sysmacros.h: New wrapper.
    
    	* misc/Makefile (headers): Add sys/sysmacros.h, bits/sysmacros.h.
    	(routines): Add makedev.
    	(tests): Add tst-makedev.
    	* misc/Versions [GLIBC_2.25]: Add gnu_dev_major, gnu_dev_minor,
    	gnu_dev_makedev.
    	* posix/Makefile (headers): Remove sys/sysmacros.h.
    	* sysdeps/unix/sysv/linux/Makefile (sysdep_routines): Remove makedev.
    
    	* sysdeps/arm/nacl/libc.abilist: Add GLIBC_2.25,
    	gnu_dev_major, gnu_dev_makedev, gnu_dev_minor.
    	* sysdeps/unix/sysv/linux/aarch64/libc.abilist
    	* sysdeps/unix/sysv/linux/alpha/libc.abilist
    	* sysdeps/unix/sysv/linux/arm/libc.abilist
    	* sysdeps/unix/sysv/linux/hppa/libc.abilist
    	* sysdeps/unix/sysv/linux/i386/libc.abilist
    	* sysdeps/unix/sysv/linux/ia64/libc.abilist
    	* sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
    	* sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
    	* sysdeps/unix/sysv/linux/microblaze/libc.abilist
    	* sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
    	* sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
    	* sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
    	* sysdeps/unix/sysv/linux/mips/mips64/n64/libc.abilist
    	* sysdeps/unix/sysv/linux/nios2/libc.abilist
    	* sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
    	* sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
    	* sysdeps/unix/sysv/linux/powerpc/powerpc64/libc-le.abilist
    	* sysdeps/unix/sysv/linux/powerpc/powerpc64/libc.abilist
    	* sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
    	* sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist
    	* sysdeps/unix/sysv/linux/sh/libc.abilist
    	* sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
    	* sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist
    	* sysdeps/unix/sysv/linux/tile/tilegx/tilegx32/libc.abilist
    	* sysdeps/unix/sysv/linux/tile/tilegx/tilegx64/libc.abilist
    	* sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist
    	* sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
    	* sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist:
    	Add GLIBC_2.25.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=cab4d74b01320670f57dcf356ff89256f4d2fc12

commit cab4d74b01320670f57dcf356ff89256f4d2fc12
Author: Zack Weinberg <zackw@panix.com>
Date:   Thu Apr 28 11:07:58 2016 -0400

    Add utility macros for clang detection, and deprecation with messages.
    
    There are three new macros added to features.h and sys/cdefs.h:
    
     * __glibc_clang_prereq: just like __GNUC_PREREQ, but for clang.
     * __glibc_clang_has_extension: wraps clang's intrinsic __has_extension.
       Writing "#if defined __clang__ && __has_extension (...)" doesn't work,
       because compilers other than clang will object to the unknown macro
       __has_extension even though they don't need to evaluate it.
       Instead, write "#if __glibc_clang_has_extension (...)".
    
     * __attribute_deprecated_msg__(msg): like __attribute_deprecated__, but
       if possible, prints a message.
    
    The first two are used to define the third.  The third will be used
    in subsequent patches.
    
    	* include/features.h (__glibc_clang_prereq): New macro.
    	* misc/sys/cdefs.h (__glibc_clang_has_extension)
    	(__attribute_deprecated_msg__): New macros.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                                          |   73 ++++++++++++
 NEWS                                               |   10 ++
 bits/sysmacros.h                                   |   74 ++++++++++++
 include/features.h                                 |   19 +++-
 include/sys/sysmacros.h                            |    1 +
 misc/Makefile                                      |    7 +-
 misc/Versions                                      |    3 +
 misc/makedev.c                                     |   30 +++++
 misc/sys/cdefs.h                                   |   22 ++++-
 misc/sys/sysmacros.h                               |  120 ++++++++++++++++++++
 misc/tst-makedev.c                                 |  104 +++++++++++++++++
 posix/Makefile                                     |    2 +-
 posix/sys/types.h                                  |    8 +-
 sysdeps/arm/nacl/libc.abilist                      |    5 +
 sysdeps/generic/sys/sysmacros.h                    |   30 -----
 sysdeps/unix/sysv/linux/Makefile                   |    2 +-
 sysdeps/unix/sysv/linux/aarch64/libc.abilist       |    1 +
 sysdeps/unix/sysv/linux/alpha/libc.abilist         |    1 +
 sysdeps/unix/sysv/linux/arm/libc.abilist           |    1 +
 sysdeps/unix/sysv/linux/hppa/libc.abilist          |    1 +
 sysdeps/unix/sysv/linux/i386/libc.abilist          |    1 +
 sysdeps/unix/sysv/linux/ia64/libc.abilist          |    1 +
 sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist |    1 +
 sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist   |    1 +
 sysdeps/unix/sysv/linux/makedev.c                  |   40 -------
 sysdeps/unix/sysv/linux/microblaze/libc.abilist    |    1 +
 .../unix/sysv/linux/mips/mips32/fpu/libc.abilist   |    1 +
 .../unix/sysv/linux/mips/mips32/nofpu/libc.abilist |    1 +
 .../unix/sysv/linux/mips/mips64/n32/libc.abilist   |    1 +
 .../unix/sysv/linux/mips/mips64/n64/libc.abilist   |    1 +
 sysdeps/unix/sysv/linux/nios2/libc.abilist         |    1 +
 .../sysv/linux/powerpc/powerpc32/fpu/libc.abilist  |    1 +
 .../linux/powerpc/powerpc32/nofpu/libc.abilist     |    1 +
 .../sysv/linux/powerpc/powerpc64/libc-le.abilist   |    1 +
 .../unix/sysv/linux/powerpc/powerpc64/libc.abilist |    1 +
 sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist  |    1 +
 sysdeps/unix/sysv/linux/s390/s390-64/libc.abilist  |    1 +
 sysdeps/unix/sysv/linux/sh/libc.abilist            |    1 +
 sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist |    1 +
 sysdeps/unix/sysv/linux/sparc/sparc64/libc.abilist |    1 +
 sysdeps/unix/sysv/linux/sys/sysmacros.h            |   65 -----------
 .../sysv/linux/tile/tilegx/tilegx32/libc.abilist   |    1 +
 .../sysv/linux/tile/tilegx/tilegx64/libc.abilist   |    1 +
 sysdeps/unix/sysv/linux/tile/tilepro/libc.abilist  |    1 +
 sysdeps/unix/sysv/linux/x86_64/64/libc.abilist     |    1 +
 sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist    |    1 +
 46 files changed, 497 insertions(+), 146 deletions(-)
 create mode 100644 bits/sysmacros.h
 create mode 100644 include/sys/sysmacros.h
 create mode 100644 misc/makedev.c
 create mode 100644 misc/sys/sysmacros.h
 create mode 100644 misc/tst-makedev.c
 delete mode 100644 sysdeps/generic/sys/sysmacros.h
 delete mode 100644 sysdeps/unix/sysv/linux/makedev.c
 delete mode 100644 sysdeps/unix/sysv/linux/sys/sysmacros.h
Comment 6 Zack Weinberg 2016-08-03 20:17:43 IST
With g++ 5 or 6, the C++ library headers don't seem to use <cstdlib> very much anymore, and in particular Shafik's original test case compiles without complaint.

It has been agreed that, in some future release, glibc's  <sys/types.h> will not include <sys/sysmacros.h> anymore.  As of 2.25, it still does, but you get deprecation warnings if you use the macros without including <sys/sysmacros.h>.  We have not decided exactly which future release will finally remove the #include; to help us decide, please send reports of software that trips the deprecation warnings to libc-alpha.

The warnings currently only happen if you use the macros in function-call context; Shafik's test case, with `#include <cstdlib>` added, does _not_ trigger them, you still get the inexplicable errors.  This will hopefully be addressed in a follow-up patch before 2.25 is released.
Comment 7 Dmitry V. Levin 2016-08-23 01:03:47 IST
Not really a glibc problem, but a direct consequence of commit https://sourceware.org/git/?p=glibc.git;a=commitdiff;h=dbab6577c6684c62bd2521c1c29dc25c3cac966f

Autoconf macro AC_HEADER_MAJOR no longer works as expected, it fails to detect that makedev from sys/types.h is deprecated:

checking whether sys/types.h defines makedev... yes

This leads to undefined MAJOR_IN_SYSMACROS, deprecation warnings, and, consequently, build errors in projects that use -Werror.
Comment 8 Zack Weinberg 2016-08-23 01:36:04 IST
(In reply to Dmitry V. Levin from comment #7) 
> Autoconf macro AC_HEADER_MAJOR no longer works as expected, it fails to
> detect that makedev from sys/types.h is deprecated:

Oh drat.  Would you please post the relevant section of config.log here?
Comment 9 Dmitry V. Levin 2016-08-23 06:24:16 IST
(In reply to Zack Weinberg from comment #8)
> (In reply to Dmitry V. Levin from comment #7) 
> > Autoconf macro AC_HEADER_MAJOR no longer works as expected, it fails to
> > detect that makedev from sys/types.h is deprecated:
> 
> Oh drat.  Would you please post the relevant section of config.log here?

config.log contains nothing interesting:

configure:3207: checking whether sys/types.h defines makedev
configure:3223: gcc -o conftest -g -O2   conftest.c  >&5
configure:3223: $? = 0
configure:3232: result: yes

The test implemented by AC_HEADER_MAJOR is simple: it just tries to compile and link "makedev(0, 0)".

Here is the relevant part of generated configure script (with empty lines removed for brevity):

{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether sys/types.h defines makedev" >&5
$as_echo_n "checking whether sys/types.h defines makedev... " >&6; }
if ${ac_cv_header_sys_types_h_makedev+:} false; then :
  $as_echo_n "(cached) " >&6
else
  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
/* end confdefs.h.  */
int
main ()
{
return makedev(0, 0);
  ;
  return 0;
}
_ACEOF
if ac_fn_c_try_link "$LINENO"; then :
  ac_cv_header_sys_types_h_makedev=yes
else
  ac_cv_header_sys_types_h_makedev=no
fi
rm -f core conftest.err conftest.$ac_objext \
    conftest$ac_exeext conftest.$ac_ext
fi
{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_header_sys_types_h_makedev" >&5
$as_echo "$ac_cv_header_sys_types_h_makedev" >&6; }
if test $ac_cv_header_sys_types_h_makedev = no; then
ac_fn_c_check_header_mongrel "$LINENO" "sys/mkdev.h" "ac_cv_header_sys_mkdev_h" "$ac_includes_default"
if test "x$ac_cv_header_sys_mkdev_h" = xyes; then :
$as_echo "#define MAJOR_IN_MKDEV 1" >>confdefs.h
fi
  if test $ac_cv_header_sys_mkdev_h = no; then
    ac_fn_c_check_header_mongrel "$LINENO" "sys/sysmacros.h" "ac_cv_header_sys_sysmacros_h" "$ac_includes_default"
if test "x$ac_cv_header_sys_sysmacros_h" = xyes; then :
$as_echo "#define MAJOR_IN_SYSMACROS 1" >>confdefs.h
fi
  fi
fi
Comment 10 Dmitry V. Levin 2016-08-30 10:49:07 IST
(In reply to Dmitry V. Levin from comment #7)
> Not really a glibc problem, but a direct consequence of commit
> https://sourceware.org/git/?p=glibc.git;a=commitdiff;
> h=dbab6577c6684c62bd2521c1c29dc25c3cac966f
> 
> Autoconf macro AC_HEADER_MAJOR no longer works as expected, it fails to
> detect that makedev from sys/types.h is deprecated:
> 
> checking whether sys/types.h defines makedev... yes
> 
> This leads to undefined MAJOR_IN_SYSMACROS, deprecation warnings, and,
> consequently, build errors in projects that use -Werror.

OK, I changed strace to include <sys/sysmacros.h> unconditionally, but for software portable beyond GNU/Linux there is no workaround available atm.
Comment 11 cvs-commit@gcc.gnu.org 2016-11-14 13:39:45 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  809b72df6c90303aa3622a28f2837ec6c518290d (commit)
      from  14f95a420313ee745b80fe71a0fe6f61b46b327c (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=809b72df6c90303aa3622a28f2837ec6c518290d

commit 809b72df6c90303aa3622a28f2837ec6c518290d
Author: Zack Weinberg <zackw@panix.com>
Date:   Mon Nov 14 08:34:59 2016 -0500

    [BZ #19239] Issue deprecation warnings on macro expansion.
    
    By using __glibc_macro_warning instead of __attribute_deprecated__,
    we get the deprecation warnings whenever the macros are expanded,
    not just when they compile to a function call.  This is important
    for unintentional uses like the test case in #19239 (C++ var(value)
    initialization syntax, with a variable named "major").  It's also
    simpler, because __REDIRECT is no longer required.
    
    	* misc/sys/sysmacros.h (__SYSMACROS_DM, __SYSMACROS_DM1): New macros.
    	(__SYSMACROS_DEPRECATION_MSG, __SYSMACROS_FST_DECL_TEMPL)
    	(__SYSMACROS_FST_IMPL_TEMPL): Delete.
    	(major, minor, makedev): Use __SYSMACROS_DM in definition, instead
    	of redirected function names.
    
    	* misc/sys/cdefs.h (__glibc_macro_warning): Activate for clang >= 3.5
    	as well.  Document that MESSAGE must be a single string literal.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog            |   11 +++++++++
 misc/sys/cdefs.h     |    7 ++++-
 misc/sys/sysmacros.h |   56 ++++++++++++++++++++-----------------------------
 3 files changed, 39 insertions(+), 35 deletions(-)
Comment 12 cvs-commit@gcc.gnu.org 2017-02-05 15:53:41 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.25 has been created
        at  be176490b818b65b5162c332eb6b581690b16e5c (tag)
   tagging  db0242e3023436757bbc7c488a779e6e3343db04 (commit)
  replaces  glibc-2.24
 tagged by  Siddhesh Poyarekar
        on  Sun Feb 5 21:19:00 2017 +0530

- Log -----------------------------------------------------------------
The GNU C Library
=================

The GNU C Library version 2.25 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.25 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.25
=====================

* The feature test macro __STDC_WANT_LIB_EXT2__, from ISO/IEC TR
  24731-2:2010, is supported to enable declarations of functions from that
  TR.  Note that not all functions from that TR are supported by the GNU C
  Library.

* The feature test macro __STDC_WANT_IEC_60559_BFP_EXT__, from ISO/IEC TS
  18661-1:2014, is supported to enable declarations of functions and macros
  from that TS.  Note that not all features from that TS are supported by
  the GNU C Library.

* The feature test macro __STDC_WANT_IEC_60559_FUNCS_EXT__, from ISO/IEC TS
  18661-4:2015, is supported to enable declarations of functions and macros
  from that TS.  Note that most features from that TS are not supported by
  the GNU C Library.

* The nonstandard feature selection macros _REENTRANT and _THREAD_SAFE are
  now treated as compatibility synonyms for _POSIX_C_SOURCE=199506L.
  Since the GNU C Library defaults to a much newer revision of POSIX, this
  will only affect programs that specifically request an old conformance
  mode.  For instance, a program compiled with -std=c89 -D_REENTRANT will
  see a change in the visible declarations, but a program compiled with
  just -D_REENTRANT, or -std=c99 -D_POSIX_C_SOURCE=200809L -D_REENTRANT,
  will not.

  Some C libraries once required _REENTRANT and/or _THREAD_SAFE to be
  defined by all multithreaded code, but glibc has not required this for
  many years.

* The inclusion of <sys/sysmacros.h> by <sys/types.h> is deprecated.  This
  means that in a future release, the macros “major”, “minor”, and “makedev”
  will only be available from <sys/sysmacros.h>.

  These macros are not part of POSIX nor XSI, and their names frequently
  collide with user code; see for instance glibc bug 19239 and Red Hat bug
  130601.  <stdlib.h> includes <sys/types.h> under _GNU_SOURCE, and C++ code
  presently cannot avoid being compiled under _GNU_SOURCE, exacerbating the
  problem.

* New <fenv.h> features from TS 18661-1:2014 are added to libm: the
  fesetexcept, fetestexceptflag, fegetmode and fesetmode functions, the
  femode_t type and the FE_DFL_MODE and FE_SNANS_ALWAYS_SIGNAL macros.

* Integer width macros from TS 18661-1:2014 are added to <limits.h>:
  CHAR_WIDTH, SCHAR_WIDTH, UCHAR_WIDTH, SHRT_WIDTH, USHRT_WIDTH, INT_WIDTH,
  UINT_WIDTH, LONG_WIDTH, ULONG_WIDTH, LLONG_WIDTH, ULLONG_WIDTH; and to
  <stdint.h>: INT8_WIDTH, UINT8_WIDTH, INT16_WIDTH, UINT16_WIDTH,
  INT32_WIDTH, UINT32_WIDTH, INT64_WIDTH, UINT64_WIDTH, INT_LEAST8_WIDTH,
  UINT_LEAST8_WIDTH, INT_LEAST16_WIDTH, UINT_LEAST16_WIDTH,
  INT_LEAST32_WIDTH, UINT_LEAST32_WIDTH, INT_LEAST64_WIDTH,
  UINT_LEAST64_WIDTH, INT_FAST8_WIDTH, UINT_FAST8_WIDTH, INT_FAST16_WIDTH,
  UINT_FAST16_WIDTH, INT_FAST32_WIDTH, UINT_FAST32_WIDTH, INT_FAST64_WIDTH,
  UINT_FAST64_WIDTH, INTPTR_WIDTH, UINTPTR_WIDTH, INTMAX_WIDTH,
  UINTMAX_WIDTH, PTRDIFF_WIDTH, SIG_ATOMIC_WIDTH, SIZE_WIDTH, WCHAR_WIDTH,
  WINT_WIDTH.

* New <math.h> features are added from TS 18661-1:2014:

  - Signaling NaN macros: SNANF, SNAN, SNANL.

  - Nearest integer functions: roundeven, roundevenf, roundevenl, fromfp,
    fromfpf, fromfpl, ufromfp, ufromfpf, ufromfpl, fromfpx, fromfpxf,
    fromfpxl, ufromfpx, ufromfpxf, ufromfpxl.

  - llogb functions: the llogb, llogbf and llogbl functions, and the
    FP_LLOGB0 and FP_LLOGBNAN macros.

  - Max-min magnitude functions: fmaxmag, fmaxmagf, fmaxmagl, fminmag,
    fminmagf, fminmagl.

  - Comparison macros: iseqsig.

  - Classification macros: iscanonical, issubnormal, iszero.

  - Total order functions: totalorder, totalorderf, totalorderl,
    totalordermag, totalordermagf, totalordermagl.

  - Canonicalize functions: canonicalize, canonicalizef, canonicalizel.

  - NaN functions: getpayload, getpayloadf, getpayloadl, setpayload,
    setpayloadf, setpayloadl, setpayloadsig, setpayloadsigf, setpayloadsigl.

* The functions strfromd, strfromf, and strfroml, from ISO/IEC TS 18661-1:2014,
  are added to libc.  They convert a floating-point number into string.

* Most of glibc can now be built with the stack smashing protector enabled.
  It is recommended to build glibc with --enable-stack-protector=strong.
  Implemented by Nick Alcock (Oracle).

* The function explicit_bzero, from OpenBSD, has been added to libc.  It is
  intended to be used instead of memset() to erase sensitive data after use;
  the compiler will not optimize out calls to explicit_bzero even if they
  are "unnecessary" (in the sense that no _correct_ program can observe the
  effects of the memory clear).

* On ColdFire, MicroBlaze, Nios II and SH3, the float_t type is now defined
  to float instead of double.  This does not affect the ABI of any libraries
  that are part of the GNU C Library, but may affect the ABI of other
  libraries that use this type in their interfaces.

* On x86_64, when compiling with -mfpmath=387 or -mfpmath=sse+387, the
  float_t and double_t types are now defined to long double instead of float
  and double.  These options are not the default, and this does not affect
  the ABI of any libraries that are part of the GNU C Library, but it may
  affect the ABI of other libraries that use this type in their interfaces,
  if they are compiled or used with those options.

* The getentropy and getrandom functions, and the <sys/random.h> header file
  have been added.

* The buffer size for byte-oriented stdio streams is now limited to 8192
  bytes by default.  Previously, on Linux, the default buffer size on most
  file systems was 4096 bytes (and thus remains unchanged), except on
  network file systems, where the buffer size was unpredictable and could be
  as large as several megabytes.

* The <sys/quota.h> header now includes the <linux/quota.h> header.  Support
  for the Linux quota interface which predates kernel version 2.4.22 has
  been removed.

* The malloc_get_state and malloc_set_state functions have been removed.
  Already-existing binaries that dynamically link to these functions will
  get a hidden implementation in which malloc_get_state is a stub.  As far
  as we know, these functions are used only by GNU Emacs and this change
  will not adversely affect already-built Emacs executables.  Any undumped
  Emacs executables, which normally exist only during an Emacs build, should
  be rebuilt by re-running “./configure; make” in the Emacs build tree.

* The “ip6-dotint” and “no-ip6-dotint” resolver options, and the
  corresponding RES_NOIP6DOTINT flag from <resolv.h> have been removed.
  “no-ip6-dotint” had already been the default, and support for the
  “ip6-dotint” option was removed from the Internet in 2006.

* The "ip6-bytestring" resolver option and the corresponding RES_USEBSTRING
  flag from <resolv.h> have been removed.  The option relied on a
  backwards-incompatible DNS extension which was never deployed on the
  Internet.

* The flags RES_AAONLY, RES_PRIMARY, RES_NOCHECKNAME, RES_KEEPTSIG,
  RES_BLAST defined in the <resolv.h> header file have been deprecated.
  They were already unimplemented.

* The "inet6" option in /etc/resolv.conf and the RES_USE_INET6 flag for
  _res.flags are deprecated.  The flag was standardized in RFC 2133, but
  removed again from the IETF name lookup interface specification in RFC
  2553.  Applications should use getaddrinfo instead.

* DNSSEC-related declarations and definitions have been removed from the
  <arpa/nameser.h> header file, and libresolv will no longer attempt to
  decode the data part of DNSSEC record types.  Previous versions of glibc
  only implemented minimal support for the previous version of DNSSEC, which
  is incompatible with the currently deployed version.

* The resource record type classification macros ns_t_qt_p, ns_t_mrr_p,
  ns_t_rr_p, ns_t_udp_p, ns_t_xfr_p have been removed from the
  <arpa/nameser.h> header file because the distinction between RR types and
  meta-RR types is not officially standardized, subject to revision, and
  thus not suitable for encoding in a macro.

* The types res_sendhookact, res_send_qhook, re_send_rhook, and the qhook
  and rhook members of the res_state type in <resolv.h> have been removed.
  The glibc stub resolver did not support these hooks, but the header file
  did not reflect that.

* For multi-arch support it is recommended to use a GCC which has
  been built with support for GNU indirect functions.  This ensures
  that correct debugging information is generated for functions
  selected by IFUNC resolvers.  This support can either be enabled by
  configuring GCC with '--enable-gnu-indirect-function', or by
  enabling it by default by setting 'default_gnu_indirect_function'
  variable for a particular architecture in the GCC source file
  'gcc/config.gcc'.

* GDB pretty printers have been added for mutex and condition variable
  structures in POSIX Threads. When installed and loaded in gdb these pretty
  printers show various pthread variables in human-readable form when read
  using the 'print' or 'display' commands in gdb.

* Tunables feature added to allow tweaking of the runtime for an application
  program.  This feature can be enabled with the '--enable-tunables' configure
  flag.  The GNU C Library manual has details on usage and README.tunables has
  instructions on adding new tunables to the library.

* A new version of condition variables functions have been implemented in
  the NPTL implementation of POSIX Threads to provide stronger ordering
  guarantees.

* A new version of pthread_rwlock functions have been implemented to use a more
  scalable algorithm primarily through not using a critical section anymore to
  make state changes.

Security related changes:

* On ARM EABI (32-bit), generating a backtrace for execution contexts which
  have been created with makecontext could fail to terminate due to a
  missing .cantunwind annotation.  This has been observed to lead to a hang
  (denial of service) in some Go applications compiled with gccgo.  Reported
  by Andreas Schwab.  (CVE-2016-6323)

* The DNS stub resolver functions would crash due to a NULL pointer
  dereference when processing a query with a valid DNS question type which
  was used internally in the implementation.  The stub resolver now uses a
  question type which is outside the range of valid question type values.
  (CVE-2015-5180)

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Alan Modra
Alexandre Oliva
Andreas Schwab
Andrew Senkevich
Aurelien Jarno
Brent W. Baccala
Carlos O'Donell
Chris Metcalf
Chung-Lin Tang
DJ Delorie
David S. Miller
Denis Kaganovich
Dmitry V. Levin
Ernestas Kulik
Florian Weimer
Gabriel F T Gomes
Gabriel F. T. Gomes
H.J. Lu
Jakub Jelinek
James Clarke
James Greenhalgh
Jim Meyering
John David Anglin
Joseph Myers
Maciej W. Rozycki
Mark Wielaard
Martin Galvan
Martin Pitt
Mike Frysinger
Märt Põder
Nick Alcock
Paul E. Murphy
Paul Murphy
Rajalakshmi Srinivasaraghavan
Rasmus Villemoes
Rical Jasan
Richard Henderson
Roland McGrath
Samuel Thibault
Siddhesh Poyarekar
Stefan Liebler
Steve Ellcey
Svante Signell
Szabolcs Nagy
Tom Tromey
Torvald Riegel
Tulio Magno Quites Machado Filho
Wilco Dijkstra
Yury Norov
Zack Weinberg
-----BEGIN PGP SIGNATURE-----

iQEcBAABAgAGBQJYl0mTAAoJEHnEPfvxzyGHXTgH/jsS205Wdz9EniZrJ6+NXCm1
F/eeOMotGNv82BYaLRnw9XrF7p6+ND8E+7rSvFZT5O309OrdLjg4QG6M63COMRCh
6KKtQUM/00I1u4AYkOOgrUkor3m58GgeQUziOxXNvQNoU8zLguPk4kzVsvxq6lJR
/IROH2Mfl1AggOGq9Y1R/0uQCpj4jJSLETxJupg4calGPZQW3isogucSmogdccAB
Bqso7L40Xo4LJnEoD7JurlMrP5x043TttmTyvnFTtxRZTAHVjyQpFMKHaSkMgtIG
+fe26Ua3oMqbE9A9G3qiMIrPEqu+0tWKbvci0FeaE30vfI6YtVcd8I0RlBW9gok=
=3NM3
-----END PGP SIGNATURE-----

Adhemerval Zanella (69):
      Fix test-skeleton C99 designed initialization
      nptl: Consolidate sem_open implementations
      nptl: Set sem_open as a non cancellation point (BZ #15765)
      nptl: Remove sparc sem_wait
      nptl: Fix sem_wait and sem_timedwait cancellation (BZ#18243)
      rt: Set shm_open as a non cancellation point (BZ #18243)
      nptl: Consolidate sem_init implementations
      posix: Correctly enable/disable cancellation on Linux posix_spawn
      posix: Correctly block/unblock all signals on Linux posix_spawn
      Add INTERNAL_SYSCALL_CALL
      posix: Fix open file action for posix_spawn on Linux
      Remove C++ style comments from string3.h
      libio: Multiple fixes for open_{w}memstram (BZ#18241 and BZ#20181)
      Fix tst-memstream3 build failure
      Consolidate fallocate{64} implementations
      Consolidate posix_fallocate{64} implementations
      Consolidate posix_fadvise implementations
      Fix iseqsig for ports that do not support FE_INVALID
      Consolidate Linux sync_file_range implementations
      Fix posix_fadvise64 build on mips64n64
      Fix Linux fallocate tests for EOPNOTSUPP
      Fix Linux sh4 pread/pwrite argument passing
      Fix sparc build due missing __WORDSIZE_TIME64_COMPAT32 definition
      Consolidate lseek/lseek64/llseek implementations
      Consolidate Linux ftruncate implementations
      Consolidate Linux truncate implementations
      Consolidate Linux access implementation
      Fix sh4 build with __ASSUME_ST_INO_64_BIT redefinition
      New internal function __access_noerrno
      Consolidate Linux setrlimit and getrlimit implementation
      Fix hurd __access_noerrno implementation.
      Fix writes past the allocated array bounds in execvpe (BZ#20847)
      Remove cached PID/TID in clone
      powerpc: Remove stpcpy internal clash with IFUNC
      powerpc: Remove stpcpy internal clash with IFUNC
      Fix writes past the allocated array bounds in execvpe (BZ#20847)
      Consolidate rename Linux implementation
      Consolidate renameat Linux implementation
      Fix powerpc64/power7 memchr for large input sizes
      Fix typos and missing closing bracket in test-memchr.c
      Adjust benchtests to new support library.
      benchtests: Add fmax/fmin benchmarks
      benchtests: Add fmaxf/fminf benchmarks
      Fix x86_64 memchr for large input sizes
      powerpc: Remove f{max,min}{f} assembly implementations
      Add __ASSUME_DIRECT_SYSVIPC_SYSCALL for Linux
      Refactor Linux ipc_priv header
      Consolidate Linux msgctl implementation
      Consolidate Linux msgrcv implementation
      Use msgsnd syscall for Linux implementation
      Use msgget syscall for Linux implementation
      Add SYSV message queue test
      Consolidate Linux semctl implementation
      Use semget syscall for Linux implementation
      Use semop syscall for Linux implementation
      Consolidate Linux semtimedop implementation
      Add SYSV semaphore test
      Use shmat syscall for Linux implementation
      Consolidate Linux shmctl implementation
      Use shmdt syscall for linux implementation
      Use shmget syscall for linux implementation
      Add SYSV shared memory test
      Fix i686 memchr for large input sizes
      Fix test-sysvsem on some platforms
      Fix x86 strncat optimized implementation for large sizes
      Remove duplicate strcat implementations
      Use fortify macros for b{zero,copy} along decl from strings.h
      Move fortified explicit_bzero back to string3
      Add missing bugzilla reference in previous ChangeLog entry

Alan Modra (1):
      powerpc32: make PLT call in _mcount compatible with -msecure-plt (bug 20554)

Alexandre Oliva (2):
      [PR19826] fix non-LE TLS in static programs
      Bug 20915: Do not initialize DTV of other threads.

Andreas Schwab (11):
      arm: mark __startcontext as .cantunwind (bug 20435)
      Properly initialize glob structure with GLOB_BRACE|GLOB_DOOFFS (bug 20707)
      Fix multiple definitions of mk[o]stemp[s]64
      Get rid of __elision_available
      Fix testsuite timeout handling
      powerpc: remove _dl_platform_string and _dl_powerpc_platforms
      Fix assertion failure on test timeout
      Fix ChangeLog typo
      Revert "Fix ChangeLog typo"
      m68k: fix 64bit atomic ops
      Fix missing test dependency

Andrew Senkevich (4):
      x86_64: Call finite scalar versions in vectorized log, pow, exp (bz #20033).
      Install libm.a as linker script (bug 20539).
      Better design of libm.a installation rule.
      Disable TSX on some Haswell processors.

Aurelien Jarno (14):
      alpha: fix ceil on sNaN input
      alpha: fix floor on sNaN input
      alpha: fix rint on sNaN input
      alpha: fix trunc for big input values
      powerpc: fix ifunc-sel.h with GCC 6
      powerpc: fix ifunc-sel.h fix asm constraints and clobber list
      sparc64: add a VIS3 version of ceil, floor and trunc
      sparc: build with -mvis on sparc32/sparcv9 and sparc64
      sparc: remove fdim sparc specific implementations
      sparc32/sparcv9: add a VIS3 version of fdim
      Set NODELETE flag after checking for NULL pointer
      conform tests: call perl with '-I.'
      gconv.h: fix build with GCC 7
      x86_64: fix static build of __memcpy_chk for compilers defaulting to PIC/PIE

Brent W. Baccala (1):
      hurd: Fix spurious port deallocation

Carlos O'Donell (17):
      Open development for 2.25.
      Update PO files.
      Bug 20292 - Simplify and test _dl_addr_inside_object
      Bug 20689: Fix FMA and AVX2 detection on Intel
      Fix atomic_fetch_xor_release.
      Add missing include for stdlib.h.
      Fix building tst-linkall-static.
      Add include/crypt.h.
      Bug 20729: Fix building with -Os.
      Bug 20729: Include libc-internal.h where required.
      Bug 20729: Fix build failures on ppc64 and other arches.
      Remove out of date PROJECTS file.
      Bug 20918 - Building with --enable-nss-crypt fails tst-linkall-static
      Bug 11941: ld.so: Improper assert map->l_init_called in dlclose
      Add deferred cancellation regression test for getpwuid_r.
      Fix failing pretty printer tests when CPPFLAGS has optimizations.
      Bug 20116: Fix use after free in pthread_create()

Chris Metcalf (6):
      Make sure tilepro uses kernel atomics fo atomic_store
      Make tile's set_dataplane API compatibility-only
      tile: create new math-tests.h header
      build-many-glibcs: Revert -fno-isolate-erroneous-paths options for tilepro
      tile: pass __IPC_64 as zero for SysV IPC calls
      tile: Check for pointer add overflow in memchr

Chung-Lin Tang (1):
      Add ipc_priv.h header for Nios II to set __IPC_64 to zero.

DJ Delorie (1):
      * elf/dl-tunables.c (tunable_set_val_if_valid_range): Split into ...

David S. Miller (4):
      Fix wide-char testsuite SIGBUS on platforms such as Sparc.
      Fix sNaN handling in nearbyint on 32-bit sparc.
      Fix a sparc header conformtest failure.
      sparc: Remove optimized math routines which cause testsuite failures.

Denis Kaganovich (1):
      configure: accept __stack_chk_fail_local for ssp support too [BZ #20662]

Dmitry V. Levin (1):
      Fix typos in the spelling of "implementation"

Ernestas Kulik (1):
      localedata: lt_LT: use hyphens in d_fmt [BZ #20497]

Florian Weimer (100):
      malloc: Preserve arena free list/thread count invariant [BZ #20370]
      malloc: Run tests without calling mallopt [BZ #19469]
      Add support for referencing specific symbol versions
      elf: dl-minimal malloc needs to respect fundamental alignment
      elf: Avoid using memalign for TLS allocations [BZ #17730]
      elf: Do not use memalign for TCB/TLS blocks allocation [BZ #17730]
      x86: Use sysdep.o from libc.a in static libraries
      Add missing reference to bug 20452
      nptl/tst-tls3-malloc: Force freeing of thread stacks
      Add NEWS entry for CVE-2016-6323
      Add CVE-2016-6323 missing from NEWS entry
      Do not override objects in libc.a in other static libraries [BZ #20452]
      nptl/tst-once5: Reduce time to expected failure
      argp: Do not override GCC keywords with macros [BZ #16907]
      string: More tests for strcmp, strcasecmp, strncmp, strncasecmp
      nptl: Avoid expected SIGALRM in most tests [BZ #20432]
      Correct incorrect bug number in changelog
      malloc: Simplify static malloc interposition [BZ #20432]
      Base <sys/quota.h> on Linux kernel headers [BZ #20525]
      vfprintf: Avoid creating a VLA which complicates stack management
      vfscanf: Avoid multiple reads of multi-byte character width
      malloc: Automated part of conversion to __libc_lock
      resolv: Remove _LIBC_REENTRANT
      Remove the ptw-% patterns
      inet: Add __inet6_scopeid_pton function [BZ #20611]
      sysd-rules: Cut down the number of rtld-% pattern rules
      Remove remnants of .og patterns
      sln: Preprocessor cleanups
      Generate .op pattern rules for profiling builds only
      Avoid running $(CXX) during build to obtain header file paths
      Add test case for O_TMPFILE handling in open, openat
      manual: Clarify the documentation of strverscmp [BZ #20524]
      Remove obsolete DNSSEC support [BZ #20591]
      resolv: Remove the BIND_4_COMPAT macro
      <arpa/nameser.h>, <arpa/nameser_compat.h>: Remove versions
      <arpa/nameser.h>: Remove RR type classification macros [BZ #20592]
      malloc: Manual part of conversion to __libc_lock
      resolv: Remove unsupported hook functions from the API [BZ #20016]
      test-skeleton.c: Remove unintended #include <stdarg.h>.
      tst-open-tmpfile: Add checks for open64, openat64, linkat
      manual: Clarify NSS error reporting
      resolv: Deprecate unimplemented flags
      resolv: Remove RES_NOIP6DOTINT and its implementation
      resolv: Remove RES_USEBSTRING and its implementation [BZ #20629]
      resolv: Compile without -Wno-write-strings
      math: Define iszero as a function template for C++ [BZ #20715]
      math.h: Wrap C++ bits in extern "C++"
      iconv: Avoid writable data and relocations in IBM charsets
      iconv: Avoid writable data and relocations in ISO646
      malloc: Remove malloc_get_state, malloc_set_state [BZ #19473]
      malloc: Use accessors for chunk metadata access
      sysmalloc: Initialize previous size field of mmaped chunks
      Add test for linking against most static libraries
      i386: Support CFLAGS which imply -fno-omit-frame-pointer [BZ #20729]
      crypt: Use internal names for the SHA-2 block functions
      malloc: Update comments about chunk layout
      nptl: Document the reason why __kind in pthread_mutex_t is part of the ABI
      s390x: Add hidden definition for __sigsetjmp
      elf: Assume TLS is initialized in _dl_map_object_from_fd
      powerpc: Remove unintended __longjmp symbol from ABI
      powerpc: Add hidden definition for __sigsetjmp
      gconv: Adjust GBK to support the Euro sign
      libio: Limit buffer size to 8192 bytes [BZ #4099]
      Implement _dl_catch_error, _dl_signal_error in libc.so [BZ #16628]
      ld.so: Remove __libc_memalign
      aarch64: Use explicit offsets in _dl_tlsdesc_dynamic
      elf/tst-tls-manydynamic: New test
      support: Introduce new subdirectory for test infrastructure
      inet: Make IN6_IS_ADDR_UNSPECIFIED etc. usable with POSIX [BZ #16421]
      debug: Additional compiler barriers for backtrace tests [BZ #20956]
      Add getentropy, getrandom, <sys/random.h> [BZ #17252]
      Expose linking against libsupport as make dependency
      nptl/tst-cancel7: Add missing case label
      Add missing bug number to ChangeLog
      Do not require memset elimination in explicit_bzero test
      Remove unused function _dl_tls_setup
      scripts/test_printers_common.py: Log GDB error message
      rpcinfo: Remove traces of unbuilt helper program
      sunrpc: Always obtain AF_INET addresses from NSS [BZ #20964]
      resolv: Remove processing of unimplemented "spoof" host.conf options
      Declare getentropy in <unistd.h> [BZ #17252]
      support: Add support for delayed test failure reporting
      Add file missing from ChangeLog in previous commit
      Fix various typos in the ChangeLog
      resolv: Turn historic name lookup functions into compat symbols
      getentropy: Declare it in <unistd.h> for __USE_MISC [BZ #17252]
      support: Helper functions for entering namespaces
      support: Use support_record_failure consistently
      support: Implement --verbose option for test programs
      resolv: Add beginnings of a libresolv test suite
      resolv: Deprecate the "inet6" option and RES_USE_INET6 [BZ #19582]
      resolv: Deprecate RES_BLAST
      tunables: Use correct unused attribute
      CVE-2015-5180: resolv: Fix crash with internal QTYPE [BZ #18784]
      Update DNS RR type definitions [BZ #20593]
      malloc: Run tunables tests only if tunables are enabled
      support: Use %td for pointer difference in xwrite
      support: struct netent portability fix for support_format_netent
      string/tst-strcoll-overflow: Do not accept timeout as test result
      nptl: Add tst-robust-fork

Gabriel F T Gomes (1):
      Fix warning caused by unused-result in bug-atexit3-lib.cc

Gabriel F. T. Gomes (10):
      Add strfromd, strfromf, and strfroml functions
      Use read_int in vfscanf
      Use write_message instead of write
      Write messages to stdout and use write_message instead of write
      Make w_log1p type-generic
      Fix arg used as litteral suffix in tst-strfrom.h
      Make w_scalbln type-generic
      Replace use of snprintf with strfrom in libm tests
      Fix typo in manual for iseqsig
      Move wrappers to libm-compat-calls-auto

H.J. Lu (8):
      X86: Change bit_YMM_state to (1 << 2)
      X86-64: Correct CFA in _dl_runtime_resolve
      X86-64: Add _dl_runtime_resolve_avx[512]_{opt|slow} [BZ #20508]
      X86: Don't assert on older Intel CPUs [BZ #20647]
      Check IFUNC definition in unrelocated shared library [BZ #20019]
      X86_64: Don't use PLT nor GOT in static archives [BZ #20750]
      Add VZEROUPPER to memset-vec-unaligned-erms.S [BZ #21081]
      Allow IFUNC relocation against unrelocated shared library

Jakub Jelinek (1):
      * soft-fp/op-common.h (_FP_MUL, _FP_FMA, _FP_DIV): Add

James Clarke (1):
      Bug 21053: sh: Reduce namespace pollution from sys/ucontext.h

James Greenhalgh (1):
      [soft-fp] Add support for various half-precision conversion routines.

Jim Meyering (1):
      assert.h: allow gcc to detect assert(a = 1) errors

John David Anglin (1):
      hppa: Optimize atomic_compare_and_exchange_val_acq

Joseph Myers (181):
      Support __STDC_WANT_LIB_EXT2__ feature test macro.
      Define PF_QIPCRTR, AF_QIPCRTR from Linux 4.7 in bits/socket.h.
      Define UDP_ENCAP_* from Linux 4.7 in netinet/udp.h.
      Support __STDC_WANT_IEC_60559_BFP_EXT__ feature test macro.
      Fix typo in last arith.texi change.
      Support __STDC_WANT_IEC_60559_FUNCS_EXT__ feature test macro.
      Also handle __STDC_WANT_IEC_60559_BFP_EXT__ in <tgmath.h>.
      Do not call __nan in scalb functions.
      Fix math.h comment about bits/mathdef.h.
      Add tests for fegetexceptflag, fesetexceptflag.
      Fix powerpc fesetexceptflag clearing FE_INVALID (bug 20455).
      Fix test-fexcept when "inexact" implicitly raised.
      Add comment from sysdeps/powerpc/fpu/fraiseexcpt.c to fsetexcptflg.c.
      Add fesetexcept.
      Add fesetexcept: aarch64.
      Add fesetexcept: alpha.
      Add fesetexcept: arm.
      Add fesetexcept: hppa.
      Add fesetexcept: ia64.
      Add fesetexcept: m68k.
      Add fesetexcept: mips.
      Add fesetexcept: powerpc.
      Add fesetexcept: s390.
      Add fesetexcept: sh.
      Add fesetexcept: sparc.
      Fix soft-fp extended.h unpacking (GCC bug 77265).
      Add fetestexceptflag.
      Add femode_t functions.
      Add femode_t functions: aarch64.
      Add femode_t functions: alpha.
      Add femode_t functions: arm.
      Add femode_t functions: hppa.
      Add femode_t functions: ia64.
      Add femode_t functions: m68k.
      Add femode_t functions: mips.
      Add femode_t functions: powerpc.
      Add femode_t functions: s390.
      Add femode_t functions: sh.
      Add femode_t functions: sparc.
      Add e500 version of fetestexceptflag.
      Add <limits.h> integer width macros.
      Add <stdint.h> integer width macros.
      Add issubnormal.
      Add iszero.
      Fix iszero for excess precision.
      Add iscanonical.
      Fix ldbl-128ibm iscanonical for -mlong-double-64.
      Use __builtin_fma more in dbl-64 code.
      Add TCP_REPAIR_WINDOW from Linux 4.8.
      Fix LONG_WIDTH, ULONG_WIDTH include ordering issue.
      Add iseqsig.
      Make iseqsig handle excess precision.
      Avoid M_NAN + M_NAN in complex functions.
      Add totalorder, totalorderf, totalorderl.
      Add more totalorder tests.
      Clean up some complex functions raising FE_INVALID.
      Add totalordermag, totalordermagf, totalordermagl.
      Define HIGH_ORDER_BIT_IS_SET_FOR_SNAN to 0 or 1.
      Add getpayload, getpayloadf, getpayloadl.
      Stop powerpc copysignl raising "invalid" for sNaN argument (bug 20718).
      Use VSQRT instruction for ARM sqrt (bug 20660).
      Use -fno-builtin for sqrt benchmark.
      Fix cmpli usage in power6 memset.
      Add getpayloadl to libnldbl.
      Add canonicalize, canonicalizef, canonicalizel.
      Make strtod raise "inexact" exceptions (bug 19380).
      Add SNAN, SNANF, SNANL macros.
      Correct clog10 documentation (bug 19673).
      Fix linknamespace parallel test failures.
      Handle tilegx* machine names.
      Add localplt.data for MIPS.
      XFAIL check-execstack for MIPS.
      Make MIPS <sys/user.h> self-contained.
      Do not hardcode platform names in manual/libm-err-tab.pl (bug 14139).
      Fix alpha sqrt fegetenv namespace (bug 20768).
      Handle tests-unsupported if run-built-tests = no.
      Do not generate UNRESOLVED results for run-built-tests = no.
      Make check-installed-headers.sh ignore sys/sysctl.h for x32.
      Update nios2 localplt.data.
      Update alpha localplt.data.
      Add localplt.data for hppa.
      Add localplt.data for sh.
      Fix rpcgen buffer overrun (bug 20790).
      Refactor some libm type-generic macros.
      Make SH <sys/user.h> self-contained.
      Ignore -Wmaybe-uninitialized in stdlib/bug-getcontext.c.
      Add script to build many glibc configurations.
      Make tilegx32 install libraries in lib32 directories.
      Fix build-many-glibcs.py style issues.
      Make SH ucontext always match current kernels.
      Fix SH4 register-dump.h for soft-float.
      Fix crypt snprintf namespace (bug 20829).
      Enable linknamespace testing for libdl and libcrypt.
      Make Alpha <sys/user.h> self-contained.
      Actually use newly built host libraries in build-many-glibcs.py.
      Quote shell commands in logs from build-many-glibcs.py.
      Add setpayload, setpayloadf, setpayloadl.
      Make build-many-glibcs.py use -fno-isolate-erroneous-paths options for tilepro.
      Fix default float_t definition (bug 20855).
      Fix x86_64 -mfpmath=387 float_t, double_t (bug 20787).
      Fix SH4 FP_ILOGB0 (bug 20859).
      More NEWS entries / fixes for float_t / double_t changes.
      Refactor float_t, double_t information into bits/flt-eval-method.h.
      Make build-many-glibcs.py track component versions requested and used.
      Add setpayloadsig, setpayloadsigf, setpayloadsigl.
      Make build-many-glibcs.py re-exec itself if changed by checkout.
      Make build-many-glibcs.py store more information about builds.
      Do not include asm/cachectl.h in nios2 sys/cachectl.h.
      Fix sysdeps/ia64/fpu/libm-symbols.h for inclusion in testcases.
      Work around IA64 tst-setcontext2.c compile failure.
      Make ilogb wrappers type-generic.
      Refactor FP_FAST_* into bits/fp-fast.h.
      Add build-many-glibcs.py bot-cycle action.
      Make build-many-glibcs.py support running as a bot.
      Refactor FP_ILOGB* out of bits/mathdef.h.
      Add missing hidden_def (__sigsetjmp).
      Make ldbl-128 getpayload, setpayload functions use _Float128.
      Add llogb, llogbf, llogbl.
      Fix pow (qNaN, 0) result with -lieee (bug 20919), remove dead parts of wrappers.
      Fix sysdeps/ieee754 pow handling of sNaN arguments (bug 20916).
      Fix x86_64/x86 powl handling of sNaN arguments (bug 20916).
      Fix hypot sNaN handling (bug 20940).
      Fix typo in last ChangeLog message.
      Add build-many-glibcs.py option to strip installed shared libraries.
      Fix tests-printers handling for cross compiling.
      Use Linux 4.9 (headers) in build-many-glibcs.py.
      Add [BZ #19398] marker to ChangeLog entry.
      Include <linux/falloc.h> in bits/fcntl-linux.h.
      Refactor long double information into bits/long-double.h.
      Fix generic fmax, fmin sNaN handling (bug 20947).
      Fix powerpc fmax, fmin sNaN handling (bug 20947).
      Fix x86, x86_64 fmax, fmin sNaN handling, add tests (bug 20947).
      Make build-many-glibcs.py flush stdout before execv.
      Define FE_SNANS_ALWAYS_SIGNAL.
      Document sNaN argument error handling.
      Add fmaxmag, fminmag functions.
      Add preprocessor indentation for llogb macro in tgmath.h.
      Add roundeven, roundevenf, roundevenl.
      Update miscellaneous files from upstream sources.
      Fix nss_nisplus build with mainline GCC (bug 20978).
      Update NEWS feature test macro description of TS 18661-1 support.
      Fix tst-support_record_failure-2 for run-built-tests = no.
      Define __intmax_t, __uintmax_t in bits/types.h.
      Add fromfp functions.
      Update copyright dates with scripts/update-copyrights.
      Update copyright dates not handled by scripts/update-copyrights.
      Update config.guess and config.sub to current versions.
      Make build-many-glibcs.py use binutils 2.28 branch by default.
      Correct MIPS math-tests.h condition for sNaN payload preservation.
      Fix math/test-nearbyint-except for no-exceptions configurations.
      Add build-many-glibcs.py powerpc-linux-gnu-power4 build.
      Fix MIPS n32 lseek, lseek64 (bug 21019).
      Fix elf/tst-ldconfig-X for cross testing.
      Fix math/test-fenvinline for no-exceptions configurations.
      Update i386 libm-test-ulps.
      Fix MicroBlaze __backtrace get_frame_size namespace (bug 21022).
      Make MIPS soft-fp preserve NaN payloads for NAN2008.
      Fix MicroBlaze bits/setjmp.h for C++.
      Update libm-test XFAILs for ibm128 format.
      Fix malloc/ tests for GCC 7 -Walloc-size-larger-than=.
      Fix string/tester.c for GCC 7 -Wstringop-overflow=.
      Fix MIPS n64 readahead (bug 21026).
      Increase some test timeouts.
      Make fallback fesetexceptflag always succeed (bug 21028).
      Update MicroBlaze localplt.data.
      Fix math/test-fenv for no-exceptions / no-rounding-modes configurations.
      Improve libm-test XFAILing for ibm128-libgcc.
      XFAIL libm-test.inc tests as needed for ibm128.
      Fix elf/sotruss-lib format-truncation error.
      Fix ld-address format-truncation error.
      Fix testsuite build for GCC 7 -Wformat-truncation.
      Make endian-conversion macros always return correct types (bug 16458).
      Make fallback fegetexceptflag work with generic fetestexceptflag.
      Fix MIPS o32 posix_fadvise.
      Make soft-float powerpc swapcontext restore the signal mask (bug 21045).
      Update install.texi latest GCC version known to work.
      Avoid parallel GCC install in build-many-glibcs.py.
      Fix ARM fpu_control.h for assemblers requiring VFP insn names (bug 21047).
      Restore clock_* librt exports for MicroBlaze (bug 21061).
      Update README.libm-test.
      Remove very old libm-test-ulps entries.

Maciej W. Rozycki (2):
      MIPS: Add `.insn' to ensure a text label is defined as code not data
      MIPS: Use R_MICROMIPS_JALR rather than R_MIPS_JALR in microMIPS code

Mark Wielaard (1):
      Reduce memory size of tsearch red-black tree.

Martin Galvan (3):
      Add pretty printers for the NPTL lock types
      Add -B to python invocation to avoid generating pyc files
      Fix up tabs/spaces mismatches

Martin Pitt (1):
      locales: en_CA: update d_fmt [BZ #9842]

Mike Frysinger (5):
      localedata: change M$ to Microsoft
      ChangeLog: change Winblowz to Windows
      ChangeLog: fix date
      localedata: GBK: add mapping for 0x80->Euro sign [BZ #20864]
      localedata: bs_BA: fix yesexpr/noexpr [BZ #20974]

Märt Põder (1):
      locales: et_EE: locale has wrong {p,n}_cs_precedes value [BZ #20459]

Nick Alcock (14):
      Move all tests out of the csu subdirectory
      x86_64: tst-quad1pie, tst-quad2pie: compile with -fPIE [BZ #7065]
      Configure support for --enable-stack-protector [BZ #7065]
      Initialize the stack guard earlier when linking statically [BZ #7065]
      Do not stack-protect ifunc resolvers [BZ #7065]
      Disable stack protector in early static initialization [BZ #7065]
      Compile the dynamic linker without stack protection [BZ #7065]
      Ignore __stack_chk_fail* in the rtld mapfile computation [BZ #7065]
      Work even with compilers which enable -fstack-protector by default [BZ #7065]
      PLT avoidance for __stack_chk_fail [BZ #7065]
      Link a non-libc-using test with -fno-stack-protector [BZ #7065]
      Drop explicit stack-protection of pieces of the system [BZ #7065]
      Do not stack-protect sigreturn stubs [BZ #7065]
      Enable -fstack-protector=* when requested by configure [BZ #7065]

Paul E. Murphy (28):
      Remove tacit double usage in ldbl-128
      Refactor part of math Makefile
      Unify drift between _Complex function type variants
      Improve gen-libm-test.pl LIT() application
      Support for type-generic libm function implementations libm
      ldbl-128: Remove unused sqrtl declaration in e_asinl.c
      Add tst-wcstod-round
      Prepare to convert _Complex cosine functions
      Convert _Complex cosine functions to generated code
      Merge common usage of mul_split function
      Prepare to convert _Complex sine functions
      Convert _Complex sine functions to generated code
      Prepare to convert _Complex tangent functions
      Convert _Complex tangent functions to generated code
      sparcv9: Restore fdiml@GLIBC_2.1
      Prepare to convert remaining _Complex functions
      Convert remaining complex function to generated files
      ldbl-128: Rename 'long double' to '_Float128'
      ldbl-128: Cleanup e_gammal_r.c after _Float128 rename
      Make common fdim implementation generic.
      Make common nextdown implementation generic.
      Make common fmax implementation generic.
      Make common fmin implementation generic.
      Remove unneeded stubs for k_rem_pio2l.
      ldbl-128: Use L(x) macro for long double constants
      Make ldexpF generic.
      Remove __nan{f,,l} macros
      Build s_nan* objects from a generic template

Paul Murphy (1):
      powerpc: Cleanup fenv_private.h

Rajalakshmi Srinivasaraghavan (5):
      Refactor strtod tests
      Add tests for strfrom functions
      powerpc: strcmp optimization for power9
      powerpc: strncmp optimization for power9
      powerpc64: strchr/strchrnul optimization for power8

Rasmus Villemoes (1):
      linux: spawni.c: simplify error reporting to parent

Rical Jasan (28):
      Manual typos: Input/Output on Streams
      Manual typos: Low-Level Input/Output
      Manual typos: File System Interface
      Manual typos: Sockets
      Manual typos: Low-Level Terminal Interface
      Manual typos: Syslog
      Manual typos: Mathematics
      Manual typos: Arithmetic Functions
      Manual typos: Date and Time
      Manual typos: Resource Usage and Limitation
      Manual typos: Non-Local Exits
      Manual typos: Signal Handling
      Manual typos: The Basic Program/System Interface
      Manual typos: Processes
      Manual typos: Job Control
      Manual typos: Users and Groups
      Manual typos: System Management
      Manual typos: System Configuration Parameters
      Manual typos: DES Encryption and Password Handling
      Manual typos: Debugging support
      Manual typos: POSIX Threads
      Manual typos: Internal probes
      Manual typos: C Language Facilities in the Library
      Manual typos: Installing
      Manual typos: Library Maintenance
      Manual typos: Contributors to
      manual: Remove non-existent mount options S_IMMUTABLE and S_APPEND [BZ #11235]
      manual: Convert @tables of variables to @vtables.

Richard Henderson (1):
      alpha: Use saturating arithmetic in memchr

Roland McGrath (3):
      NaCl: Fix compile error in clock function.
      Fix generic wait3 after union wait_status removal.
      NaCl: Fix compile error for __dup after libc_hidden_proto addition.

Samuel Thibault (12):
      Fix recvmsg returning SIGLOST on PF_LOCAL sockets
      mach: Add more allowed external headers
      hurd: fix pathconf visibility
      hurd: fix fcntl visibility
      Fix exc2signal.c template
      mach: Fix old-style function definition.
      Fix old-style function definition
      hurdmalloc: Run fork handler as late as possible [BZ #19431]
      hurd: Fix stack pointer corruption in syscall
      hurd: Fix unused variable warning
      hurd: fix using hurd/signal.h in C++ programs
      hurd: fix using hurd.h in C++ programs

Siddhesh Poyarekar (47):
      Consolidate reduce_and_compute code
      Add fall through comments
      Use fabs(x) instead of branching on signedness of input to sin and cos
      Consolidate input partitioning into do_cos and do_sin
      Use do_sin for sin(x) where 0.25 < |x| < 0.855469
      Inline all support functions for sin and cos
      Remove __libc_csu_irel declaration
      Add tests-static to tests in malloc/Makefile
      consolidate sign checks for slow2
      Use copysign instead of ternary conditions for positive constants
      Use copysign instead of ternary for some sin/cos input ranges
      Make the quadrant shift K a bool in do_sincos_* functions
      Check n instead of k1 to decide on sign of sin/cos result
      Manual typos: System Databases and Name Service Switch
      Make quadrant shift a boolean in reduce_and_compute in s_sin.c
      Adjust calls to do_sincos_1 and do_sincos_2 in s_sincos.c
      Update comments for some functions in s_sin.c
      Add note on MALLOC_MMAP_* environment variables
      Document the M_ARENA_* mallopt parameters
      Remove references to sbrk to grow/shrink arenas
      Remove redundant definitions of M_ARENA_* macros
      Static inline functions for mallopt helpers
      Regenerate ULPs for aarch64
      Add ChangeLog for previous commit
      Link benchset tests against libsupport
      Add configure check for python program
      Fix pretty printer tests for run-built-tests == no
      Add framework for tunables
      Initialize tunable list with the GLIBC_TUNABLES environment variable
      Enhance --enable-tunables to select tunables frontend at build time
      User manual documentation for tunables
      Add NEWS item for tunables
      tunables: Avoid getenv calls and disable glibc.malloc.check by default
      Regenerate libc.pot
      Update translations from the Translation Project
      Merge translations from the Translation Project
      Fix typo in NEWS
      Merge translations from the Translation Project
      Fix environment traversal when an envvar value is empty
      Add target to incorporate translations from translations.org
      tunables: Fix environment variable processing for setuid binaries (bz #21073)
      Drop GLIBC_TUNABLES for setxid programs when tunables is disabled (bz #21073)
      tunables: Fail tests correctly when setgid does not work
      Add missing NEWS items
      Add list of bugs fixed in 2.25
      Add more contributors to contrib.texi
      Update for 2.25 release

Stefan Liebler (22):
      Get rid of array-bounds warning in __kernel_rem_pio2[f] with gcc 6.1 -O3.
      S390: Do not set FE_INEXACT with feraiseexcept (FE_OWERFLOW|FE_UNDERFLOW).
      S390: Support PLT and GOT references in check-localplt.
      S390: Regenerate ULPs
      Add configure check to test if gcc supports attribute ifunc.
      Use gcc attribute ifunc in libc_ifunc macro instead of inline assembly due to false debuginfo.
      s390: Refactor ifunc resolvers due to false debuginfo.
      i386, x86: Use libc_ifunc macro for time, gettimeofday.
      ppc: Use libc_ifunc macro for time, gettimeofday.
      Use libc_ifunc macro for clock_* symbols in librt.
      Use libc_ifunc macro for system in libpthread.
      Use libc_ifunc macro for vfork in libpthread.
      Use libc_ifunc macro for siglongjmp, longjmp in libpthread.
      S390: Fix fp comparison not raising FE_INVALID.
      Fix new testcase elf/tst-latepthread on s390x.
      S390: Regenerate ULPs.
      S390: Use C11-like atomics instead of plain memory accesses in lock elision code.
      S390: Use own tbegin macro instead of __builtin_tbegin.
      S390: Use new __libc_tbegin_retry macro in elision-lock.c.
      S390: Optimize lock-elision by decrementing adapt_count at unlock.
      S390: Fix FAIL in test string/tst-xbzero-opt [BZ #21006]
      S390: Adjust lock elision code after review.

Steve Ellcey (14):
      Fix -Wformat-length warning in tst-setgetname.c
      Fix warning from latest GCC in tst-printf.c
      Fix -Wformat-length warning in time/tst-strptime2.c
      Define wordsize.h macros everywhere
      Speed up math/test-tgmath2.c
      Document do_test in test-skeleton.c
      Define __ASSUME_ST_INO_64_BIT on all platforms.
      Add definitions to sysdeps/tile/tilepro/bits/wordsize.h.
      Always define XSTAT_IS_XSTAT64
      Allow [f]statfs64 to alias [f]statfs
      Fix for [f]statfs64/[f]statfs aliasing patch
      Partial ILP32 support for aarch64.
      Use XSTAT_IS_XSTAT64 in generic xstat functions
      Add comments to check-c++-types.sh.

Svante Signell (1):
      hurd: Fix adjtime call with OLDDELTA == NULL

Szabolcs Nagy (1):
      Make build-many-glibcs.py work on python3.2

Tom Tromey (1):
      Update and install proc_service.h [BZ #20311]

Torvald Riegel (12):
      Add atomic_exchange_relaxed.
      Add atomic operations required by the new condition variable.
      Fix incorrect double-checked locking related to _res_hconf.initialized.
      Use C11-like atomics instead of plain memory accesses in x86 lock elision.
      Robust mutexes: Fix lost wake-up.
      New condvar implementation that provides stronger ordering guarantees.
      Fix pthread_cond_t on sparc for new condvar.
      New pthread rwlock that is more scalable.
      robust mutexes: Fix broken x86 assembly by removing it
      Clear list of acquired robust mutexes in the child process after forking.
      Add compiler barriers around modifications of the robust mutex list.
      Fix mutex pretty printer test and pretty printer output.

Tulio Magno Quites Machado Filho (9):
      powerpc: Fix POWER9 implies
      powerpc: Installed-header hygiene
      powerpc: Regenerate ULPs
      powerpc: Fix TOC stub on powerpc64 clone()
      Document a behavior of an elided pthread_rwlock_unlock
      powerpc: Fix powerpc32/power7 memchr for large input sizes
      powerpc: Fix write-after-destroy in lock elision [BZ #20822]
      powerpc: Regenerate ULPs
      powerpc: Fix adapt_count update in __lll_unlock_elision

Wilco Dijkstra (4):
      An optimized memchr was missing for AArch64.  This version is similar to
      Improve generic rawmemchr for targets that don't have an
      Improve strtok and strtok_r performance.  Instead of calling strpbrk which
      This patch cleans up the strsep implementation and improves performance.

Yury Norov (1):
      * sysdeps/unix/sysv/linux/fxstat.c: Remove useless cast.

Zack Weinberg (20):
      Add utility macros for clang detection, and deprecation with messages.
      Minimize sysdeps code involved in defining major/minor/makedev.
      Deprecate inclusion of <sys/sysmacros.h> by <sys/types.h>
      Add tests for fortification of bcopy and bzero.
      Installed-header hygiene (BZ#20366): Simple self-contained fixes.
      Installed-header hygiene (BZ#20366): obsolete BSD u_* types.
      Installed-header hygiene (BZ#20366): conditionally defined structures.
      Installed-header hygiene (BZ#20366): time.h types.
      Installed-header hygiene (BZ#20366): stack_t.
      Installed header hygiene (BZ#20366): Test of installed headers.
      Minor correction to the "installed header hygiene" patches.
      Minor corrections to scripts/check-installed-headers.sh.
      [BZ #19239] Issue deprecation warnings on macro expansion.
      Fix typo in string/bits/string2.h.
      Fix build-and-build-again bug in sunrpc tests.
      Forgot to add the ChangeLog to the previous commit, doh.
      Correct comments in string.h re strcoll_l, strxfrm_l.
      Minor problems exposed by compiling C++ tests under _ISOMAC.
      Make _REENTRANT and _THREAD_SAFE aliases for _POSIX_C_SOURCE=199506L.
      New string function explicit_bzero (from OpenBSD).

steve ellcey-CA Eng-Software (1):
      Fix warnings from latest GCC.

-----------------------------------------------------------------------
Comment 13 cvs-commit@gcc.gnu.org 2018-02-12 12:36:44 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  e16deca62e16f645213dffd4ecd1153c37765f17 (commit)
      from  de800d83059dbedb7d151580f0a3bdc9eaf37340 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e16deca62e16f645213dffd4ecd1153c37765f17

commit e16deca62e16f645213dffd4ecd1153c37765f17
Author: Zack Weinberg <zackw@panix.com>
Date:   Wed Feb 7 15:45:58 2018 -0500

    [BZ #19239] Don't include sys/sysmacros.h from sys/types.h.
    
    This completes the deprecation and removal of this inclusion, which
    was begun in the 2.25 release.
    
    	* posix/sys/types.h: Don't include sys/sysmacros.h.
    	* misc/sys/sysmacros.h: Remove the conditional deprecation
    	warnings for the macros defined by this header.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog            |    7 ++++++
 NEWS                 |   11 ++++++++++
 misc/sys/sysmacros.h |   52 ++-----------------------------------------------
 posix/sys/types.h    |    9 --------
 4 files changed, 21 insertions(+), 58 deletions(-)
Comment 14 Joseph Myers 2018-02-15 21:06:18 IST
As I understand it, the last commit fixed this for 2.28.
Comment 15 Zack Weinberg 2018-02-15 21:16:31 IST
That's correct.  I did not remember whether one was supposed to close the bug now or leave it open until the release.
Comment 16 cvs-commit@gcc.gnu.org 2018-08-01 05:53:22 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.28 has been created
        at  0774a9618b539692317d0950477e16a8c5074caf (tag)
   tagging  3c03baca37fdcb52c3881e653ca392bba7a99c2b (commit)
  replaces  glibc-2.27.9000
 tagged by  Carlos O'Donell
        on  Wed Aug 1 01:20:23 2018 -0400

- Log -----------------------------------------------------------------
The GNU C Library
=================

The GNU C Library version 2.28 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.28 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.28
=====================

Major new features:

* The localization data for ISO 14651 is updated to match the 2016
  Edition 4 release of the standard, this matches data provided by
  Unicode 9.0.0.  This update introduces significant improvements to the
  collation of Unicode characters.  This release deviates slightly from
  the standard in that the collation element ordering for lowercase and
  uppercase LATIN script characters is adjusted to ensure that regular
  expressions with ranges like [a-z] and [A-Z] don't interleave e.g. A
  is not matched by [a-z].  With the update many locales have been
  updated to take advantage of the new collation information.  The new
  collation information has increased the size of the compiled locale
  archive or binary locales.

* The GNU C Library can now be compiled with support for Intel CET, AKA
  Intel Control-flow Enforcement Technology.  When the library is built
  with --enable-cet, the resulting glibc is protected with indirect
  branch tracking (IBT) and shadow stack (SHSTK).  CET-enabled glibc is
  compatible with all existing executables and shared libraries.  This
  feature is currently supported on i386, x86_64 and x32 with GCC 8 and
  binutils 2.29 or later.  Note that CET-enabled glibc requires CPUs
  capable of multi-byte NOPs, like x86-64 processors as well as Intel
  Pentium Pro or newer.  NOTE: --enable-cet has been tested for i686,
  x86_64 and x32 on non-CET processors.  --enable-cet has been tested
  for x86_64 and x32 on CET SDVs, but Intel CET support hasn't been
  validated for i686.

* The GNU C Library now has correct support for ABSOLUTE symbols
  (SHN_ABS-relative symbols).  Previously such ABSOLUTE symbols were
  relocated incorrectly or in some cases discarded.  The GNU linker can
  make use of the newer semantics, but it must communicate it to the
  dynamic loader by setting the ELF file's identification (EI_ABIVERSION
  field) to indicate such support is required.

* Unicode 11.0.0 Support: Character encoding, character type info, and
  transliteration tables are all updated to Unicode 11.0.0, using
  generator scripts contributed by Mike FABIAN (Red Hat).

* <math.h> functions that round their results to a narrower type are added
  from TS 18661-1:2014 and TS 18661-3:2015:

  - fadd, faddl, daddl and corresponding fMaddfN, fMaddfNx, fMxaddfN and
    fMxaddfNx functions.

  - fsub, fsubl, dsubl and corresponding fMsubfN, fMsubfNx, fMxsubfN and
    fMxsubfNx functions.

  - fmul, fmull, dmull and corresponding fMmulfN, fMmulfNx, fMxmulfN and
    fMxmulfNx functions.

  - fdiv, fdivl, ddivl and corresponding fMdivfN, fMdivfNx, fMxdivfN and
    fMxdivfNx functions.

* Two grammatical forms of month names are now supported for the following
  languages: Armenian, Asturian, Catalan, Czech, Kashubian, Occitan, Ossetian,
  Scottish Gaelic, Upper Sorbian, and Walloon.  The following languages now
  support two grammatical forms in abbreviated month names: Catalan, Greek,
  and Kashubian.

* Newly added locales: Lower Sorbian (dsb_DE) and Yakut (sah_RU) also
  include the support for two grammatical forms of month names.

* Building and running on GNU/Hurd systems now works without out-of-tree
  patches.

* The renameat2 function has been added, a variant of the renameat function
  which has a flags argument.  If the flags are zero, the renameat2 function
  acts like renameat.  If the flag is not zero and there is no kernel
  support for renameat2, the function will fail with an errno value of
  EINVAL.  This is different from the existing gnulib function renameatu,
  which performs a plain rename operation in case of a RENAME_NOREPLACE
  flags and a non-existing destination (and therefore has a race condition
  that can clobber the destination inadvertently).

* The statx function has been added, a variant of the fstatat64
  function with an additional flags argument.  If there is no direct
  kernel support for statx, glibc provides basic stat support based on
  the fstatat64 function.

* IDN domain names in getaddrinfo and getnameinfo now use the system libidn2
  library if installed.  libidn2 version 2.0.5 or later is recommended.  If
  libidn2 is not available, internationalized domain names are not encoded
  or decoded even if the AI_IDN or NI_IDN flags are passed to getaddrinfo or
  getnameinfo.  (getaddrinfo calls with non-ASCII names and AI_IDN will fail
  with an encoding error.)  Flags which used to change the IDN encoding and
  decoding behavior (AI_IDN_ALLOW_UNASSIGNED, AI_IDN_USE_STD3_ASCII_RULES,
  NI_IDN_ALLOW_UNASSIGNED, NI_IDN_USE_STD3_ASCII_RULES) have been
  deprecated.  They no longer have any effect.

* Parsing of dynamic string tokens in DT_RPATH, DT_RUNPATH, DT_NEEDED,
  DT_AUXILIARY, and DT_FILTER has been expanded to support the full
  range of ELF gABI expressions including such constructs as
  '$ORIGIN$ORIGIN' (if valid).  For SUID/GUID applications the rules
  have been further restricted, and where in the past a dynamic string
  token sequence may have been interpreted as a literal string it will
  now cause a load failure.  These load failures were always considered
  unspecified behaviour from the perspective of the dynamic loader, and
  for safety are now load errors e.g. /foo/${ORIGIN}.so in DT_NEEDED
  results in a load failure now.

* Support for ISO C threads (ISO/IEC 9899:2011) has been added.  The
  implementation includes all the standard functions provided by
  <threads.h>:

  - thrd_current, thrd_equal, thrd_sleep, thrd_yield, thrd_create,
    thrd_detach, thrd_exit, and thrd_join for thread management.

  - mtx_init, mtx_lock, mtx_timedlock, mtx_trylock, mtx_unlock, and
    mtx_destroy for mutual exclusion.

  - call_once for function call synchronization.

  - cnd_broadcast, cnd_destroy, cnd_init, cnd_signal, cnd_timedwait, and
    cnd_wait for conditional variables.

  - tss_create, tss_delete, tss_get, and tss_set for thread-local storage.

  Application developers must link against libpthread to use ISO C threads.

Deprecated and removed features, and other changes affecting compatibility:

* The nonstandard header files <libio.h> and <_G_config.h> are no longer
  installed.  Software that was using either header should be updated to
  use standard <stdio.h> interfaces instead.

* The stdio functions 'getc' and 'putc' are no longer defined as macros.
  This was never required by the C standard, and the macros just expanded
  to call alternative names for the same functions.  If you hoped getc and
  putc would provide performance improvements over fgetc and fputc, instead
  investigate using (f)getc_unlocked and (f)putc_unlocked, and, if
  necessary, flockfile and funlockfile.

* All stdio functions now treat end-of-file as a sticky condition.  If you
  read from a file until EOF, and then the file is enlarged by another
  process, you must call clearerr or another function with the same effect
  (e.g. fseek, rewind) before you can read the additional data.  This
  corrects a longstanding C99 conformance bug.  It is most likely to affect
  programs that use stdio to read interactive input from a terminal.
  (Bug #1190.)

* The macros 'major', 'minor', and 'makedev' are now only available from
  the header <sys/sysmacros.h>; not from <sys/types.h> or various other
  headers that happen to include <sys/types.h>.  These macros are rarely
  used, not part of POSIX nor XSI, and their names frequently collide with
  user code; see https://sourceware.org/bugzilla/show_bug.cgi?id=19239 for
  further explanation.

  <sys/sysmacros.h> is a GNU extension.  Portable programs that require
  these macros should first include <sys/types.h>, and then include
  <sys/sysmacros.h> if __GNU_LIBRARY__ is defined.

* The tilegx*-*-linux-gnu configurations are no longer supported.

* The obsolete function ustat is no longer available to newly linked
  binaries; the headers <ustat.h> and <sys/ustat.h> have been removed.  This
  function has been deprecated in favor of fstatfs and statfs.

* The obsolete function nfsservctl is no longer available to newly linked
  binaries.  This function was specific to systems using the Linux kernel
  and could not usefully be used with the GNU C Library on systems with
  version 3.1 or later of the Linux kernel.

* The obsolete function name llseek is no longer available to newly linked
  binaries.  This function was specific to systems using the Linux kernel
  and was not declared in a header.  Programs should use the lseek64 name
  for this function instead.

* The AI_IDN_ALLOW_UNASSIGNED and NI_IDN_ALLOW_UNASSIGNED flags for the
  getaddrinfo and getnameinfo functions have been deprecated.  The behavior
  previously selected by them is now always enabled.

* The AI_IDN_USE_STD3_ASCII_RULES and NI_IDN_USE_STD3_ASCII_RULES flags for
  the getaddrinfo and getnameinfo functions have been deprecated.  The STD3
  restriction (rejecting '_' in host names, among other things) has been
  removed, for increased compatibility with non-IDN name resolution.

* The fcntl function now have a Long File Support variant named fcntl64.  It
  is added to fix some Linux Open File Description (OFD) locks usage on non
  LFS mode.  As for others *64 functions, fcntl64 semantics are analogous with
  fcntl and LFS support is handled transparently.  Also for Linux, the OFD
  locks act as a cancellation entrypoint.

* The obsolete functions encrypt, encrypt_r, setkey, setkey_r, cbc_crypt,
  ecb_crypt, and des_setparity are no longer available to newly linked
  binaries, and the headers <rpc/des_crypt.h> and <rpc/rpc_des.h> are no
  longer installed.  These functions encrypted and decrypted data with the
  DES block cipher, which is no longer considered secure.  Software that
  still uses these functions should switch to a modern cryptography library,
  such as libgcrypt.

* Reflecting the removal of the encrypt and setkey functions above, the
  macro _XOPEN_CRYPT is no longer defined.  As a consequence, the crypt
  function is no longer declared unless _DEFAULT_SOURCE or _GNU_SOURCE is
  enabled.

* The obsolete function fcrypt is no longer available to newly linked
  binaries.  It was just another name for the standard function crypt,
  and it has not appeared in any header file in many years.

* We have tentative plans to hand off maintenance of the passphrase-hashing
  library, libcrypt, to a separate development project that will, we hope,
  keep up better with new passphrase-hashing algorithms.  We will continue
  to declare 'crypt' in <unistd.h>, and programs that use 'crypt' or
  'crypt_r' should not need to change at all; however, distributions will
  need to install <crypt.h> and libcrypt from a separate project.

  In this release, if the configure option --disable-crypt is used, glibc
  will not install <crypt.h> or libcrypt, making room for the separate
  project's versions of these files.  The plan is to make this the default
  behavior in a future release.

Changes to build and runtime requirements:

  GNU make 4.0 or later is now required to build glibc.

Security related changes:

  CVE-2016-6261, CVE-2016-6263, CVE-2017-14062: Various vulnerabilities have
  been fixed by removing the glibc-internal IDNA implementation and using
  the system-provided libidn2 library instead.  Originally reported by Hanno
  Böck and Christian Weisgerber.

  CVE-2017-18269: An SSE2-based memmove implementation for the i386
  architecture could corrupt memory.  Reported by Max Horn.

  CVE-2018-11236: Very long pathname arguments to realpath function could
  result in an integer overflow and buffer overflow.  Reported by Alexey
  Izbyshev.

  CVE-2018-11237: The mempcpy implementation for the Intel Xeon Phi
  architecture could write beyond the target buffer, resulting in a buffer
  overflow.  Reported by Andreas Schwab.

The following bugs are resolved with this release:

  [1190] stdio: fgetc()/fread() behaviour is not POSIX compliant
  [6889] manual: 'PWD' mentioned but not specified
  [13575] libc: SSIZE_MAX defined as LONG_MAX is inconsistent with ssize_t,
    when __WORDSIZE != 64
  [13762] regex: re_search etc. should return -2 on memory exhaustion
  [13888] build: /tmp usage during testing
  [13932] math: dbl-64 pow unexpectedly slow for some inputs
  [14092] nptl: Support C11 threads
  [14095] localedata: Review / update collation data from Unicode / ISO
    14651
  [14508] libc: -Wformat warnings
  [14553] libc: Namespace pollution loff_t in sys/types.h
  [14890] libc: Make NT_PRFPREG canonical.
  [15105] libc: Extra PLT references with -Os
  [15512] libc: __bswap_constant_16 not compiled when -Werror -Wsign-
    conversion is given
  [16335] manual: Feature test macro documentation incomplete and out of
    date
  [16552] libc: Unify umount implementations in terms of umount2
  [17082] libc: htons et al.: statement-expressions prevent use on global
    scope with -O1 and higher
  [17343] libc: Signed integer overflow in /stdlib/random_r.c
  [17438] localedata: pt_BR: wrong d_fmt delimiter
  [17662] libc: please implement binding for the new renameat2 syscall
  [17721] libc: __restrict defined as /* Ignore */ even in c11
  [17979] libc: inconsistency between uchar.h and stdint.h
  [18018] dynamic-link: Additional $ORIGIN handling issues (CVE-2011-0536)
  [18023] libc: extend_alloca is broken (questionable pointer comparison,
    horrible machine code)
  [18124] libc: hppa: setcontext erroneously returns -1 as exit code for
    last constant.
  [18471] libc: llseek should be a compat symbol
  [18473] soft-fp: [powerpc-nofpu] __sqrtsf2, __sqrtdf2 should be compat
    symbols
  [18991] nss: nss_files skips large entry in database
  [19239] libc: Including stdlib.h ends up with macros major and minor being
    defined
  [19463] libc: linknamespace failures when compiled with -Os
  [19485] localedata: csb_PL: Update month translations + add yesstr/nostr
  [19527] locale: Normalized charset name not recognized by setlocale
  [19667] string: Missing Sanity Check for malloc calls in file 'testcopy.c'
  [19668] libc: Missing Sanity Check for malloc() in file 'tst-setcontext-
    fpscr.c'
  [19728] network: out of bounds stack read in libidn function
    idna_to_ascii_4i (CVE-2016-6261)
  [19729] network: out of bounds heap read on invalid utf-8 inputs in
    stringprep_utf8_nfkc_normalize (CVE-2016-6263)
  [19818] dynamic-link: Absolute (SHN_ABS) symbols incorrectly relocated by
    the base address
  [20079] libc: Add SHT_X86_64_UNWIND to elf.h
  [20251] libc: 32bit programs pass garbage in struct flock for OFD locks
  [20419] dynamic-link: files with large allocated notes crash in
    open_verify
  [20530] libc: bswap_16 should use __builtin_bswap16() when available
  [20890] dynamic-link: ldconfig: fsync the files before atomic rename
  [20980] manual: CFLAGS environment variable replaces vital options
  [21163] regex: Assertion failure in pop_fail_stack when executing a
    malformed regexp (CVE-2015-8985)
  [21234] manual: use of CFLAGS makes glibc detect no optimization
  [21269] dynamic-link: i386 sigaction sa_restorer handling is wrong
  [21313] build: Compile Error GCC 5.4.0 MIPS with -0S
  [21314] build: Compile Error GCC 5.2.0 MIPS with -0s
  [21508] locale: intl/tst-gettext failure with latest msgfmt
  [21547] localedata: Tibetan script collation broken (Dzongkha and Tibetan)
  [21812] network: getifaddrs() returns entries with ifa_name == NULL
  [21895] libc: ppc64 setjmp/longjmp not fully interoperable with static
    dlopen
  [21942] dynamic-link: _dl_dst_substitute incorrectly handles $ORIGIN: with
    AT_SECURE=1
  [22241] localedata: New locale: Yakut (Sakha) locale for Russia (sah_RU)
  [22247] network: Integer overflow in the decode_digit function in
    puny_decode.c in libidn (CVE-2017-14062)
  [22342] nscd: NSCD not properly caching netgroup
  [22391] nptl: Signal function clear NPTL internal symbols inconsistently
  [22550] localedata: es_ES locale (and  other es_* locales):  collation
    should treat ñ  as a primary different character,  sync the collation
    for Spanish with CLDR
  [22638] dynamic-link: sparc: static binaries are broken if glibc is built
    by gcc configured with --enable-default-pie
  [22639] time: year 2039 bug for localtime etc. on 64-bit platforms
  [22644] string: memmove-sse2-unaligned on 32bit x86 produces garbage when
    crossing 2GB threshold (CVE-2017-18269)
  [22646] localedata: redundant data (LC_TIME) for es_CL, es_CU, es_EC and
    es_BO
  [22735] time: Misleading typo in time.h source comment regarding
    CLOCKS_PER_SECOND
  [22753] libc: preadv2/pwritev2 fallback code should handle offset=-1
  [22761] libc: No trailing `%n' conversion specifier in FMT passed from
    `__assert_perror_fail ()' to `__assert_fail_base ()'
  [22766] libc: all glibc internal dlopen should use RTLD_NOW for robust
    dlopen failures
  [22786] libc: Stack buffer overflow in realpath() if input size is close
    to SSIZE_MAX (CVE-2018-11236)
  [22787] dynamic-link: _dl_check_caller returns false when libc is linked
    through an absolute DT_NEEDED path
  [22792] build: tcb-offsets.h dependency dropped
  [22797] libc: pkey_get() uses non-reserved name of argument
  [22807] libc: PTRACE_* constants missing for powerpc
  [22818] glob: posix/tst-glob_lstat_compat failure on alpha
  [22827] dynamic-link: RISC-V ELF64 parser mis-reads flag in ldconfig
  [22830] malloc: malloc_stats doesn't restore cancellation state on stderr
  [22848] localedata: ca_ES: update date definitions from CLDR
  [22862] build: _DEFAULT_SOURCE is defined even when _ISOC11_SOURCE is
  [22884] math: RISCV fmax/fmin handle signalling NANs incorrectly
  [22896] localedata: Update locale data for an_ES
  [22902] math: float128 test failures with GCC 8
  [22918] libc: multiple common of `__nss_shadow_database'
  [22919] libc: sparc32: backtrace yields infinite backtrace with
    makecontext
  [22926] libc: FTBFS on powerpcspe
  [22932] localedata: lt_LT: Update of abbreviated month names from CLDR
    required
  [22937] localedata: Greek (el_GR, el_CY) locales actually need ab_alt_mon
  [22947] libc: FAIL: misc/tst-preadvwritev2
  [22963] localedata: cs_CZ: Add alternative month names
  [22987] math: [powerpc/sparc] fdim inlines errno, exceptions handling
  [22996] localedata: change LC_PAPER to en_US in es_BO locale
  [22998] dynamic-link: execstack tests are disabled when SELinux is
    disabled
  [23005] network: Crash in __res_context_send after memory allocation
    failure
  [23007] math: strtod cannot handle -nan
  [23024] nss: getlogin_r is performing NSS lookups when loginid isn't set
  [23036] regex: regex equivalence class regression
  [23037] libc: initialize msg_flags to zero for sendmmsg() calls
  [23069] libc: sigaction broken on riscv64-linux-gnu
  [23094] localedata: hr_HR: wrong thousands_sep and mon_thousands_sep
  [23102] dynamic-link: Incorrect parsing of multiple consecutive $variable
    patterns in runpath entries (e.g. $ORIGIN$ORIGIN)
  [23137] nptl: s390: pthread_join sometimes block indefinitely (on 31bit
    and libc build with -Os)
  [23140] localedata: More languages need two forms of month names
  [23145] libc: _init/_fini aren't marked as hidden
  [23152] localedata: gd_GB: Fix typo in "May" (abbreviated)
  [23171] math: C++ iseqsig for long double converts arguments to double
  [23178] nscd: sudo will fail when it is run in concurrent with commands
    that changes /etc/passwd
  [23196] string: __mempcpy_avx512_no_vzeroupper mishandles large copies
    (CVE-2018-11237)
  [23206] dynamic-link: static-pie + dlopen breaks debugger interaction
  [23208] localedata: New locale - Lower Sorbian (dsb)
  [23233] regex: Memory leak in build_charclass_op function in file
    posix/regcomp.c
  [23236] stdio: Harden function pointers in _IO_str_fields
  [23250] nptl: Offset of __private_ss differs from GCC
  [23253] math: tgamma test suite failures on i686 with -march=x86-64
    -mtune=generic -mfpmath=sse
  [23259] dynamic-link: Unsubstituted ${ORIGIN} remains in DT_NEEDED for
    AT_SECURE
  [23264] libc: posix_spawnp wrongly executes ENOEXEC in non compat mode
  [23266] nis: stringop-truncation warning with new gcc8.1 in nisplus-
    parser.c
  [23272] math: fma(INFINITY,INFIITY,0.0) should be INFINITY
  [23277] math: nan function should not have const attribute
  [23279] math: scanf and strtod wrong for some hex floating-point
  [23280] math: wscanf rounds wrong; wcstod is ok for negative numbers and
    directed rounding
  [23290] localedata: IBM273 is not equivalent to ISO-8859-1
  [23303] build: undefined reference to symbol
    '__parse_hwcap_and_convert_at_platform@@GLIBC_2.23'
  [23307] dynamic-link: Absolute symbols whose value is zero ignored in
    lookup
  [23313] stdio: libio vtables validation and standard file object
    interposition
  [23329] libc: The __libc_freeres infrastructure is not properly run across
    DSO boundaries.
  [23349] libc: Various glibc headers no longer compatible with
    <linux/time.h>
  [23351] malloc: Remove unused code related to heap dumps and malloc
    checking
  [23363] stdio: stdio-common/tst-printf.c has non-free license
  [23396] regex: Regex equivalence regression in single-byte locales
  [23422] localedata: oc_FR: More updates of locale data
  [23442] build: New warning with GCC 8
  [23448] libc: Out of bounds access in IBM-1390 converter
  [23456] libc: Wrong index_cpu_LZCNT
  [23458] build: tst-get-cpu-features-static isn't added to tests
  [23459] libc: COMMON_CPUID_INDEX_80000001 isn't populated for Intel
    processors
  [23467] dynamic-link: x86/CET: A property note parser bug

Release Notes
=============

https://sourceware.org/glibc/wiki/Release/2.28

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Agustina Arzille
Alan Modra
Alexandre Oliva
Amit Pawar
Andreas Schwab
Andrew Senkevich
Andrew Waterman
Aurelien Jarno
Carlos O'Donell
Chung-Lin Tang
DJ Delorie
Daniel Alvarez
David Michael
Dmitry V. Levin
Dragan Stanojevic - Nevidljivi
Florian Weimer
Flávio Cruz
Francois Goichon
Gabriel F. T. Gomes
H.J. Lu
Herman ten Brugge
Hongbo Zhang
Igor Gnatenko
Jesse Hathaway
John David Anglin
Joseph Myers
Leonardo Sandoval
Maciej W. Rozycki
Mark Wielaard
Martin Sebor
Michael Wolf
Mike FABIAN
Patrick McGehearty
Patsy Franklin
Paul Pluzhnikov
Quentin PAGÈS
Rafal Luzynski
Rajalakshmi Srinivasaraghavan
Raymond Nicholson
Rical Jasan
Richard Braun
Robert Buj
Rogerio Alves
Samuel Thibault
Sean McKean
Siddhesh Poyarekar
Stefan Liebler
Steve Ellcey
Sylvain Lesage
Szabolcs Nagy
Thomas Schwinge
Tulio Magno Quites Machado Filho
Valery Timiriliyev
Vincent Chen
Wilco Dijkstra
Zack Weinberg
Zong Li
-----BEGIN PGP SIGNATURE-----

iQIcBAABAgAGBQJbYUMhAAoJEBZ5K06iU0D4LV8QAJDI+9To34wUWGmYUmV48NFx
9Mug7Yd7Y8kpo0Rxi/yPpBBAjQadz4zJftkvZJUlZsYL83jypgRhxlXaOvyBATqT
COHK3+RRaKqTcnBgSQmR34tGJh1k9CSfvfmRWxs1SycQQMhTbkQ7bLEGJEWDava6
PYCsQloDAaZdjumHNCoyTbg9fObqUlyqw3OyRJYWx07Bbl2nQc6Y/WLb4pgdWz0Y
yy7kNM6P70+uFbb/+9iPnXJ4avWbpXO68Y1WeuMFtiL7sQ/qr6sNQ1HHdqut94LB
XF7tiQ3/vWkMoJT+GkQr0rhrlTXBv+h77NFTPuewRPviYWgIWMThk3T7D2+TM8Sn
Y9hkKTpCA2qrDRK6IMMzxKAfo9+DyO66cSXM3cwCzKOtpMXdlZqRg9TlAFMjmXGr
r1KFpZzdHdw5qqktYQnIa1JBh0+31JhWXB/XxvoJx5nSDuBbJ4x55M8IeG3PCy3x
ejgCJ6bJODOChlGhE6FN4VJM+WSjd8ZY8K4T2XGdP+3zVc+zyNqLDTpdydR6t1nB
H5Peqbg12g8IJD7kY/i4Jm2uFpxP32CD3lUhp2gEbACRlZTmcxc6Bl13jgEdgKrW
AD1dxH7i9xI/Rff2hp23U5d1NAiJmWTfAgUU2939rYU+02UWUPnk/TvzMzIaTYGo
MIRvKIvblBn6bCUxYTQP
=dTj9
-----END PGP SIGNATURE-----

Adhemerval Zanella (48):
      Update SH libm-tests-ulps
      Rename nptl-signals.h to internal-signals.h
      Refactor atfork handlers
      Update sparc ulps
      i386: Fix i386 sigaction sa_restorer initialization (BZ#21269)
      nptl: Fix tst-cancel4 sendto tests
      Define _DIRENT_MATCHES_DIRENT64 regardless
      Refactor Linux ARCH_FORK implementation
      powerpc: Fix TLE build for SPE (BZ #22926)
      sparc: Fix arch_fork definition
      Add Changelog reference to BZ#23024
      Assume O_DIRECTORY for opendir
      Filter out NPTL internal signals (BZ #22391)
      linux: Consolidate sigaction implementation
      Update ARM libm-test-ulps.
      Update SPARC libm-test-ulps.
      Update i386 libm-test-ulps.
      Consolidate Linux readdir{64}{_r} implementation
      arm: Remove ununsed ARM code in optimized implementation
      Consolidate Linux getdents{64} implementation
      Fix mips64n32 getdents alias
      Consolidate scandir{at}{64} implementation
      Update hppa libm-test-ulps
      Consolidate alphasort{64} and versionsort{64} implementation
      Consolidate getdirentries{64} implementation
      Consolidate Linux readahead implementation
      Deprecate ustat syscall interface
      Fix ChangeLog from cf2478d53ad commit
      Fix concurrent changes on nscd aware files (BZ #23178)
      posix: Fix posix_spawnp to not execute invalid binaries in non compat mode (BZ#23264)
      Fix Linux fcntl OFD locks for non-LFS architectures (BZ#20251)
      Revert hurd errno.h changes
      Fix hurd expected fcntl version
      posix: Sync gnulib regex implementation
      posix: Fix bug-regex33 after regex sync
      Comment tst-ofdlocks-compat expected failure in some Linux releases
      nptl: Add C11 threads thrd_* functions
      nptl: Add C11 threads mtx_* functions
      nptl: Add C11 threads call_once functions
      nptl: Add C11 threads cnd_* functions
      nptl: Add C11 threads tss_* functions
      nptl: Add abilist symbols for C11 threads
      nptl: Add test cases for ISO C11 threads
      Mention ISO C threads addition
      Fix C11 conformance issues
      Fix ISO C threads installed header and HURD assumption
      Fix Linux fcntl OFD locks on unsupported kernels
      Update SH libm-tests-ulps

Agustina Arzille (2):
      hurd: Rewrite __libc_cleanup_*
      hurd: Reimplement libc locks using mach's gsync

Alan Modra (1):
      R_PARISC_TLS_DTPOFF32 reloc handling

Alexandre Oliva (1):
      Revert:

Amit Pawar (1):
      Use AVX_Fast_Unaligned_Load from Zen onwards.

Andreas Schwab (11):
      Fix uninitialized variable in assert_perror (bug 22761)
      Fix multiple definitions of __nss_*_database (bug 22918)
      RISC-V: add remaining relocations
      Fix crash in resolver on memory allocation failure (bug 23005)
      Fix missing @ before texinfo command
      Add aliases to recognize normalized charset names (bug 19527)
      Fix comment typo
      Remove unneeded setting of errno after malloc failure
      Don't write beyond destination in __mempcpy_avx512_no_vzeroupper (bug 23196)
      Fix out-of-bounds access in IBM-1390 converter (bug 23448)
      Fix out of bounds access in findidxwc (bug 23442)

Andrew Senkevich (1):
      Fix i386 memmove issue (bug 22644).

Andrew Waterman (1):
      RISC-V: fmax/fmin: Handle signalling NaNs correctly.

Aurelien Jarno (4):
      intl/tst-gettext: fix failure with newest msgfmt
      Fix posix/tst-glob_lstat_compat on alpha [BZ #22818]
      sparc32: Add nop before __startcontext to stop unwinding [BZ #22919]
      Add tst-sigaction.c to test BZ #23069

Carlos O'Donell (17):
      Fix -Os log1p, log1pf build (bug 21314).
      Improve DST handling (Bug 23102, Bug 21942, Bug 18018, Bug 23259).
      Fix fallback path in __pthread_mutex_timedlock ().
      Fix comments in _dl_dst_count and _dl_dst_substitute.
      libc: Extend __libc_freeres framework (Bug 23329).
      locale: XFAIL newlocale usage in static binary (Bug 23164)
      Keep expected behaviour for [a-z] and [A-z] (Bug 23393).
      Add missing localedata/en_US.UTF-8.in (Bug 23393).
      Update libc.pot.
      Update NEWS with ISO 14651 update information.
      Update translations for cs, pl, and uk.
      Update translations for bg, de, hr, pt_BR, sv, and vi.
      Update translation for be.
      Update contrib.texi contributions.
      Update tooling versions verified to work with glibc.
      Synchronize translation project PO files.
      Update NEWS, version.h, and features.h for glibc 2.28.

Chung-Lin Tang (1):
      Update sysdeps/nios2/libm-test-ulps

DJ Delorie (5):
      [RISC-V] Fix parsing flags in ELF64 files.
      RISC-V: Do not initialize $gp in TLS macros.
      Update ChangeLog for BZ 22884 - riscv fmax/fmin
      [BZ #22342] Fix netgroup cache keys.
      Update kernel version in syscall-names.list to 4.16.

Daniel Alvarez (1):
      getifaddrs: Don't return ifa entries with NULL names [BZ #21812]

David Michael (1):
      Lookup the startup server through /servers/startup

Dmitry V. Levin (3):
      linux/aarch64: sync sys/ptrace.h with Linux 4.15 [BZ #22433]
      linux/powerpc: sync sys/ptrace.h with Linux 4.15 [BZ #22433, #22807]
      Update translations from the Translation Project

Dragan Stanojevic - Nevidljivi (1):
      hr_HR locale: fix thousands_sep and mon_thousands_sep

Florian Weimer (72):
      preadv2/pwritev2: Handle offset == -1 [BZ #22753]
      Record CVE-2018-6551 in NEWS and ChangeLog [BZ #22774]
      getlogin_r: switch Linux variant to struct scratch_buffer
      elf: Remove ad-hoc restrictions on dlopen callers [BZ #22787]
      ldconfig: Sync temporary files to disk before renaming them [BZ #20890]
      nptl: Move pthread_atfork to libc_nonshared.a
      nptl: Drop libpthread_nonshared.a from libpthread.so
      nptl: Turn libpthread.so into a symbolic link to the real DSO
      malloc: Revert sense of prev_inuse in comments
      Linux i386: tst-bz21269 triggers SIGBUS on some kernels
      support_format_addrinfo: Include unknown error number in result
      inet: Actually build and run tst-deadline
      manual: Move mbstouwcs to an example C file
      manual: Various fixes to the mbstouwcs example, and mbrtowc update
      resolv: Fully initialize struct mmsghdr in send_dg [BZ #23037]
      sunrpc: Remove stray exports without --enable-obsolete-rpc [BZ #23166]
      time: Use 64-bit time values for time zone parsing
      math: Merge strtod_nan_*.h into math-type-macros-*.h
      support: Add TEST_COMPARE_BLOB, support_quote_blob
      math: Reverse include order in <math-type-macros-*.h>
      i386: Drop -mpreferred-stack-boundary=4
      Implement allocate_once for atomic initialization with allocation
      Switch IDNA implementation to libidn2 [BZ #19728] [BZ #19729] [BZ #22247]
      Add references to CVE-2017-18269, CVE-2018-11236, CVE-2018-11237
      stdlib: Additional tests need generated locale dependencies
      support: Add wrappers for pthread_barrierattr_t
      libio: Avoid _allocate_buffer, _free_buffer function pointers [BZ #23236]
      Remove sysdeps/generic/libcidn.abilist
      math: Update i686 ulps
      math: Update i686 ulps (--disable-multi-arch configuration)
      x86: Make strncmp usable from rtld
      scripts/update-abilist.sh: Accept empty list of files to patch
      localedata: Make IBM273 compatible with ISO-8859-1 [BZ #23290]
      Linux: Create Netlink socket with SOCK_CLOEXEC in __check_pf [BZ #15722]
      libio: Avoid ptrdiff_t overflow in IO_validate_vtable
      math: Set 387 and SSE2 rounding mode for tgamma on i386 [BZ #23253]
      nscd restart: Use malloc instead of extend_alloca [BZ #18023]
      nscd: Use struct scratch_buffer, not extend_alloca in most caches [BZ #18023]
      nscd: Switch to struct scratch_buffer in adhstaiX [BZ #18023]
      getgrent_next_nss (compat-initgroups): Remove alloca fallback [BZ #18023]
      _nss_nis_initgroups_dyn: Use struct scratch_buffer [BZ #18023]
      getent: Use dynarray in initgroups_keys [BZ #18023]
      nss_files: Use struct scratch_buffer instead of extend_alloca [BZ #18023]
      libio: Disable vtable validation in case of interposition [BZ #23313]
      support: Add TEST_NO_SETVBUF
      libio: Add tst-vtables, tst-vtables-interposed
      sunrpc: Remove always-defined _RPC_THREAD_SAFE_ macro
      Run thread shutdown functions in an explicit order
      wordexp: Rewrite parse_tilde to use struct scratch_buffer [BZ #18023]
      gethostid (Linux variant): Switch to struct scratch_buffer [BZ #18023]
      _dl_map_object_deps: Use struct scratch_buffer [BZ #18023]
      Remove macros extend_alloca, extend_alloca_account [BZ #18023]
      Use _STRUCT_TIMESPEC as guard in <bits/types/struct_timespec.h> [BZ #23349]
      malloc: Update heap dumping/undumping comments [BZ #23351]
      stdio-common/tst-printf.c: Remove part under a non-free license [BZ #23363]
      testrun.sh: Implement --tool=strace, --tool=valgrind
      Add renameat2 function [BZ #17662]
      Compile debug/stack_chk_fail_local.c with stack protector
      Build csu/elf-init.c and csu/static-reloc.c with stack protector
      conform/conformtest.pl: Escape literal braces in regular expressions
      libio: Implement internal function __libc_readline_unlocked
      nss_files: Fix re-reading of long lines [BZ #18991]
      Fix copyright years in recent commits
      regexec: Fix off-by-one bug in weight comparison [BZ #23036]
      Add the statx function
      Install <bits/statx.h> header
      nptl: Use __mprotect consistently for _STACK_GROWS_UP
      regcomp: Fix off-by-one bug in build_equiv_class [BZ #23396]
      sh: Do not define __ASSUME_STATX
      alpha: mlock2, copy_file_range syscalls were introduced in kernel 4.13
      C11 threads: Fix timeout and locking issues
      htl: Use weak aliases for public symbols

Flávio Cruz (1):
      hurd: Define and pass UTIME_NOW and UTIME_OMIT to new file_utimens RPC

Francois Goichon (1):
      malloc: harden removal from unsorted list

Gabriel F. T. Gomes (3):
      powerpc64*: fix the order of implied sysdeps directories
      Fix parameter type in C++ version of iseqsig (bug 23171)
      ldbl-128ibm-compat: Add printf_size

H.J. Lu (76):
      sparc: Check PIC instead of SHARED in start.S [BZ #22638]
      x86-64: Use __glibc_likely/__glibc_likely in dl-machine.h
      Add a missing ChangeLog item in commit 371b220f620
      Fix a typo in ChangeLog entry
      i386: Use __glibc_likely/__glibc_likely in dl-machine.h
      Add DT_SYMTAB_SHNDX from gABI
      Use ADDRIDX with DT_GNU_HASH
      Define GEN_AS_CONST_HEADERS when generating header files [BZ #22792]
      Fix a typo in ChangeLog (bit_cpu_BIT -> bit_cpu_IBT)
      Fix a typo in ChangeLog: auch_fork -> arch_fork
      Remove hidden __libc_longjmp
      Add $(tests-execstack-$(have-z-execstack)) after defined [BZ #22998]
      Update RWF_SUPPORTED for Linux kernel 4.16 [BZ #22947]
      x86: Use pad in pthread_unwind_buf to preserve shadow stack register
      x86-64/setcontext: Pop the pointer into %rdx after syscall
      cl
      x86-64/swapcontext: Restore the pointer into %rdx after syscall
      x86-64/memset: Mark the debugger symbol as hidden
      x86-64: Remove the unnecessary testl in strlen-avx2.S
      x86: Add sysdeps/x86/ldsodefs.h
      i386: Replace PREINIT_FUNCTION@PLT with *%eax in call
      x86-64: Use IFUNC strncat inside libc.so
      nptl: Remove __ASSUME_PRIVATE_FUTEX
      Initial Fast Short REP MOVSB (FSRM) support
      x86-64: Check Prefer_FSRM in ifunc-memmove.h
      Add a test case for [BZ #23196]
      x86-64: Skip zero length in __mem[pcpy|move|set]_erms
      static-PIE: Update DT_DEBUG for debugger [BZ #23206]
      Mark _init and _fini as hidden [BZ #23145]
      i386: Change offset of __private_ss to 0x30 [BZ #23250]
      benchtests: Add -f/--functions argument
      x86: Rename __glibc_reserved1 to feature_1 in tcbhead_t [BZ #22563]
      x86: Support shadow stack pointer in setjmp/longjmp
      x86_64: Undef SHADOW_STACK_POINTER_OFFSET last
      x86: Support IBT and SHSTK in Intel CET [BZ #21598]
      x86: Always include <dl-cet.h>/cet-tunables.h> for --enable-cet
      x86: Add _CET_ENDBR to functions in crti.S
      x86: Add _CET_ENDBR to functions in dl-tlsdesc.S
      x86-64: Add _CET_ENDBR to STRCMP_SSE42
      i386: Add _CET_ENDBR to indirect jump targets in add_n.S/sub_n.S
      x86_64: Use _CET_NOTRACK in strcmp.S
      x86-64: Use _CET_NOTRACK in strcpy-sse2-unaligned.S
      x86-64: Use _CET_NOTRACK in strcmp-sse42.S
      x86-64: Use _CET_NOTRACK in memcpy-ssse3-back.S
      x86-64: Use _CET_NOTRACK in memcpy-ssse3.S
      i386: Use _CET_NOTRACK in i686/memcmp.S
      i386: Use _CET_NOTRACK in memset-sse2.S
      i386: Use _CET_NOTRACK in memcmp-sse4.S
      i386: Use _CET_NOTRACK in memcpy-ssse3-rep.S
      i386: Use _CET_NOTRACK in memcpy-ssse3.S
      i386: Use _CET_NOTRACK in strcpy-sse2.S
      i386: Use _CET_NOTRACK in strcat-sse2.S
      i386: Use _CET_NOTRACK in memset-sse2-rep.S
      x86-64: Use _CET_NOTRACK in memcmp-sse4.S
      Intel CET: Document --enable-cet
      x86/CET: Document glibc.tune.x86_ibt and glibc.tune.x86_shstk
      INSTALL: Add a note for Intel CET status
      x86-64: Add endbr64 to tst-quadmod[12].S
      x86: Update vfork to pop shadow stack
      Add <bits/indirect-return.h>
      x86/CET: Extend arch_prctl syscall for CET control
      x86: Rename __glibc_reserved2 to ssp_base in tcbhead_t
      x86/CET: Add tests with legacy non-CET shared objects
      Add a test for multiple makecontext calls
      Add another test for setcontext
      Add a test for multiple setcontext calls
      Add tests for setcontext on the context from makecontext
      x86-64/CET: Extend ucontext_t to save shadow stack
      x86/CET: Add a setcontext test for CET
      ia64: Work around incorrect type of IA64 uc_sigmask
      x86: Correct index_cpu_LZCNT [BZ # 23456]
      x86: Populate COMMON_CPUID_INDEX_80000001 for Intel CPUs [BZ #23459]
      Add the missing ChangeLog entry for commit be525a69a66
      x86/CET: Don't parse beyond the note end
      x86: Add tst-get-cpu-features-static to $(tests) [BZ #23458]
      x86/CET: Fix property note parser [BZ #23467]

Herman ten Brugge (1):
      Fix sign of NaN returned by strtod (bug 23007).

Hongbo Zhang (1):
      aarch64: add HXT Phecda core memory operation ifuncs

Igor Gnatenko (1):
      Linux: use reserved name __key in pkey_get [BZ #22797]

Jesse Hathaway (1):
      getlogin_r: return early when linux sentinel value is set

John David Anglin (2):
      Fix ulps for pow on hppa.
      The hppa-linux target still requires an executable stack for kernel

Joseph Myers (110):
      Do not use packed structures in soft-fp.
      Fix m68k bits/fenv.h for no-FPU ColdFire.
      Add ColdFire math-tests.h.
      Move some fenv.h override macros to generic math_private.h.
      Move fenv.h override inline functions to generic math_private.h.
      Add feholdexcept inline in generic math_private.h.
      Remove some math_private.h libc_fe* overrides.
      Remove some math_private.h libc_feholdexcept_setround overrides.
      Move LDBL_CLASSIFY_COMPAT to its own header.
      Update syscall-names.list for 4.15.
      Add MAP_SHARED_VALIDATE from Linux 4.15.
      Add MAP_SYNC from Linux 4.15.
      Add elf.h NT_* macros from Linux 4.15 (bug 14890).
      Add IPV6_FREEBIND from Linux 4.15.
      Add TCP_FASTOPEN_KEY, TCP_FASTOPEN_NO_COOKIE from Linux 4.15.
      Only define loff_t for __USE_MISC (bug 14553).
      Use xmalloc in tst-setcontext-fpscr.c (bug 19668).
      Correct type of SSIZE_MAX for 32-bit (bug 13575).
      Move string/testcopy.c to test-driver.c and xmalloc (bug 19667).
      Fix non-__GNUC__ definitions of __inline and __restrict (bug 17721).
      Unify and simplify bits/byteswap.h, bits/byteswap-16.h headers (bug 14508, bug 15512, bug 17082, bug 20530).
      Fix -Os strcoll, wcscoll, build (bug 21313).
      Fix -Os gnu_dev_* linknamespace, localplt issues (bug 15105, bug 19463).
      Use MPFR 4.0.1 in build-many-glibcs.py.
      Define char16_t, char32_t consistently with uint_least16_t, uint_least32_t (bug 17979).
      Remove unused math/Makefile variable libm-test-incs.
      Add build infrastructure for narrowing libm functions.
      Add test infrastructure for narrowing libm functions.
      Handle narrowing function sNaN test disabling based on argument format.
      Fix narrowing function tests build for powerpc64le.
      Add narrowing add functions.
      Fix -Os feof_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Use libc_hidden_* for fputs (bug 15105).
      Use libc_hidden_* for __cmsg_nxthdr (bug 15105).
      Use libc_hidden_* for argz_next, __argz_next (bug 15105).
      Fix hppa local PLT entries for sigprocmask (bug 18124).
      Document use of CC and CFLAGS in more detail (bug 20980, bug 21234).
      Fix -Os ferror_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Fix -Os getc_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Fix -Os putc_unlocked, fputc_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Use libc_hidden_* for tolower, toupper (bug 15105).
      Use libc_hidden_* for atoi (bug 15105).
      Fix another -Os strcoll build issue.
      Fix two more -Os strcoll / wcscoll build failures.
      Use libc_hidden_* for strtoumax (bug 15105).
      Fix i386 fenv_private.h float128 for 32-bit --with-fpmath=sse (bug 22902).
      Fix powerpc ifunc-sel.h build for -Os.
      Fix s390 -Os iconv build.
      Remove old-GCC parts of x86 bits/mathinline.h.
      Remove more old-compilers parts of sysdeps/x86/fpu/bits/mathinline.h.
      Update i386 libm-test-ulps.
      Remove sysdeps/x86/fpu/bits/mathinline.h __finite inline.
      Add SHT_X86_64_UNWIND to elf.h (bug 20079).
      Add narrowing subtract functions.
      Fix signed integer overflow in random_r (bug 17343).
      Remove powerpc, sparc fdim inlines (bug 22987).
      Use x86_64 backtrace as generic version.
      Remove unused frame.h header, sigcontextinfo.h macros.
      Unify umount function implementations (bug 16552).
      Use Linux 4.16 in build-many-glibcs.py.
      Make build-many-glibcs.py build GCC for powerpcspe with --enable-obsolete.
      Update aarch64 bits/hwcap.h, dl-procinfo.c for Linux 4.16 HWCAP_ASIMDFHM.
      Define XTABS to TAB3 on alpha to match Linux 4.16.
      Add NT_PPC_PKEY from Linux 4.16 to elf.h.
      Add PTRACE_SECCOMP_GET_METADATA from Linux 4.16 to sys/ptrace.h.
      Fix Hurd glibc build with GCC 8.
      Use GCC 8 in build-many-glibcs.py by default.
      Remove tilegx port.
      Ignore absolute symbols in ABI tests.
      Move math_narrow_eval to separate math-narrow-eval.h.
      Move math_opt_barrier, math_force_eval to separate math-barriers.h.
      Move math_check_force_underflow macros to separate math-underflow.h.
      Do not include math-barriers.h in math_private.h.
      Add narrowing multiply functions.
      Update MIPS libm-test-ulps.
      Add narrowing divide functions.
      Fix year 2039 bug for localtime with 64-bit time_t (bug 22639).
      Obsolete nfsservctl.
      Split test-tgmath3 by function.
      Make llseek a compat symbol (bug 18471).
      Fix i686-linux-gnu build with GCC mainline.
      Remove sysdeps/aarch64/soft-fp directory.
      Remove sysdeps/alpha/soft-fp directory.
      Remove sysdeps/sh/soft-fp directory.
      Remove sysdeps/powerpc/soft-fp directory.
      Remove sysdeps/sparc/sparc32/soft-fp directory.
      Remove sysdeps/sparc/sparc64/soft-fp directory.
      Make powerpc-nofpu __sqrtsf2, __sqrtdf2 compat symbols (bug 18473).
      Use Linux 4.17 in build-many-glibcs.py.
      Update kernel version in syscall-names.list to 4.17.
      Add MAP_FIXED_NOREPLACE from Linux 4.17 to bits/mman.h.
      Add AArch64 hwcap values from Linux 4.17.
      Fix ldbl-96 fma (Inf, Inf, finite) (bug 23272).
      Do not use const attribute for nan functions (bug 23277).
      Fix strtod overflow detection (bug 23279).
      Ignore -Wrestrict for one strncat test.
      Add tests for sign of NaN returned by strtod (bug 23007).
      Fix powerpc64le build of nan-sign tests (bug 23303).
      Update MAP_TYPE value for hppa from Linux 4.17.
      Add MSG_STAT_ANY from Linux 4.17 to bits/msq.h.
      Add SEM_STAT_ANY from Linux 4.17 to bits/sem.h.
      Add SHM_STAT_ANY from Linux 4.17 to bits/shm.h.
      Fix scanf rounding of negative floating-point numbers (bug 23280).
      Fix bug-strspn1.c, bug-strpbrk1.c build with GCC mainline.
      Fix tst-cmp.c build with GCC mainline.
      Fix hardcoded /tmp paths in testing (bug 13888).
      Remove nptl/sockperf.c.
      Avoid insecure usage of tmpnam in tests.
      Use binutils 2.31 branch in build-many-glibcs.py.
      Update powerpc-nofpu ulps.

Leonardo Sandoval (6):
      x86-64: remove duplicate line on PREFETCH_ONE_SET macro
      Add missing changelog from previous commit
      x86-64: Optimize strcmp/wcscmp and strncmp/wcsncmp with AVX2
      benchtests: Add --no-diff and --no-header options
      benchtests: Catch exceptions in input arguments
      benchtests: improve argument parsing through argparse library

Maciej W. Rozycki (6):
      nptl_db: Remove stale `match_pid' parameter from `iterate_thread_list'
      elf: Unify symbol address run-time calculation [BZ #19818]
      elf: Correct absolute (SHN_ABS) symbol run-time calculation [BZ #19818]
      nisplus: Correct pwent parsing issue and resulting build error [BZ #23266]
      elf: Accept absolute (SHN_ABS) symbols whose value is zero [BZ #23307]
      libc-abis: Define ABSOLUTE ABI [BZ #19818][BZ #23307]

Mark Wielaard (1):
      elf.h: Add BPF relocation types.

Martin Sebor (1):
      Document interaction with GCC built-ins in the Customizing Printf

Michael Wolf (1):
      New locale: Lower Sorbian (dsb_DE) [BZ #23208]

Mike FABIAN (23):
      Add missing “reorder-end” in LC_COLLATE of et_EE [BZ #22517]
      Use “copy "es_BO"” in LC_TIME of es_CU, es_CL, and es_EC
      Use / instead of - in d_fmt for pt_BR and pt_PT [BZ #17438]
      Remove --quiet argument when installing locales
      Update iso14651_t1_common file to ISO14651_2016_TABLE1_en.txt [BZ #14095]
      Necessary changes after updating the iso14651_t1_common file
      iso14651_t1_common: <U\([0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]\)> → <U000\1>
      Fixing syntax errors after updating the iso14651_t1_common file
      Add convenience symbols like <AFTER-A>, <BEFORE-A> to iso14651_t1_common
      iso14651_t1_common: make the fourth level the codepoint for characters which are ignorable on all 4 levels
      Add sections for various scripts to the iso14651_t1_common file
      Collation order of ȥ has changed in new iso14651_t1_common file, adapt test files
      Collation order of @-. and space has changed in new iso14651_t1_common file, adapt test files
      Fix posix/bug-regex5.c test case, adapt to iso14651_t1_common upate
      Fix test cases tst-fnmatch and tst-regexloc for the new iso14651_t1_common file.
      Improve gen-locales.mk and gen-locale.sh to make test files with @ options work
      Adapt collation in several locales to the new iso14651_t1_common file
      Remove the lines from cmn_TW.UTF-8.in which cannot work at the moment.
      bg_BG locale: Fix a typo in a comment
      an_ES locale: update some locale data [BZ #22896]
      Fix tst-strfmon_l test for hr_HR locale
      Bug 23308: Update to Unicode 11.0.0
      Put the correct Unicode version number 11.0.0 into the generated files

Patrick McGehearty (1):
      Improves __ieee754_exp(x) performance by 18-37% when |x| < 1.0397

Patsy Franklin (1):
      In sem_open.c,  pad was not initialized when __HAVE_64B_ATOMICS was

Paul Pluzhnikov (3):
      Fix BZ 20419.  A PT_NOTE in a binary could be arbitratily large, so using
      Fix BZ 22786: integer addition overflow may cause stack buffer overflow
      Update ulps with "make regen-ulps" on AMD Ryzen 7 1800X.

Quentin PAGÈS (1):
      oc_FR locale: Multiple updates (bug 23140, bug 23422).

Rafal Luzynski (13):
      lt_LT locale: Update abbreviated month names (bug 22932).
      Greek (el_CY, el_GR) locales: Introduce ab_alt_mon (bug 22937).
      cs_CZ locale: Add alternative month names (bug 22963).
      NEWS: Mention the locale data changes (bug 22848, 22937, 22963).
      gd_GB: Fix typo in abbreviated "May" (bug 23152).
      gd_GB, hsb_DE, wa_BE: Add alternative month names (bug 23140).
      csb_PL: Update month translations + add yesstr/nostr (bug 19485).
      csb_PL: Add alternative month names (bug 23140).
      ast_ES: Add alternative month names (bug 23140).
      hy_AM: Add alternative month names (bug 23140).
      dsb_DE locale: Fix syntax error and add tests (bug 23208).
      os_RU: Add alternative month names (bug 23140).
      NEWS: Avoid the words "nominative" and "genitive".

Rajalakshmi Srinivasaraghavan (3):
      powerpc: Add multiarch sqrtf128 for ppc64le
      ldbl-128ibm-compat: Introduce ieee128 symbols
      Add long double input for strfmon test

Raymond Nicholson (1):
      manual/startup.texi (Aborting a Program): Remove inappropriate joke.

Rical Jasan (9):
      manual: Fix Texinfo warnings about improper node names.
      manual: Fix a syntax error.
      manual: Improve documentation of get_current_dir_name. [BZ #6889]
      manual: Document missing feature test macros.
      manual: Update the _ISOC99_SOURCE description.
      manual: Update _DEFAULT_SOURCE.  [BZ #22862]
      Fix a typo in a comment.
      Add [BZ #16335] annotation to ChangeLog entry.
      Add manual documentation for threads.h

Richard Braun (1):
      Hurd: fix port leak in TLS

Robert Buj (1):
      ca_ES locale: Update LC_TIME (bug 22848).

Rogerio Alves (1):
      powerpc64: Always restore TOC on longjmp [BZ #21895]

Samuel Thibault (131):
      hurd: Fix build
      nscd: don't unconditionally use PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP
      hurd: Define EXEC_PAGESIZE
      hurd: Fix build on missing __ptsname_internal function
      hurd: fix build
      hurd: Add sysdep-cancel.h
      Move NPTL-specific code to NPTL-specific header
      hurd: fix timer_routines.c build
      hurd: fix gai_misc build
      hurd: fix timer_routines.c build
      hurd: do not check Mach and Hurd headers
      hurd: Add missing includes
      hurd: Add missing includes
      hurd: Move mach/param.h to bits/mach/param.h
      hurd: avoid including hurd/signal.h when not needed
      hurd: fix header conformity
      hurd: Add missing include
      hurd: Avoid using ino64_t and loff_t in headers
      hurd: Fix inclusion of mach headers in all standards
      hurd: Make almost all hurd headers includable in all standards
      Separate out error_t definition
      hurd: Add futimens support
      hurd: Fix includability of <hurd/signal.h> in all standards
      hurd: Add futimesat and utimensat support
      Add missing start-of-file descriptive comment.
      hurd: add gscope support
      hurd: add TLS support
      hurd: Fix getting signal thread stack layout for fork
      hurd: Replace threadvars with TLS
      hurd: Fix link cthread/pthread symbol exposition.
      hurd: Fix coding style
      x86_64: Fix build with RTLD_PRIVATE_ERRNO defined to 1
      hurd: Add missing include
      hurd: Fix copyright years
      hurd: Fix O_NOFOLLOW
      hurd: Fix O_DIRECTORY | O_NOFOLLOW
      hurd: Fix boot with statically-linked exec server
      hurd: Add mlockall support
      hurd: fix build
      hurd: Fix build with latest htl
      hurd: Code style fixes
      Fix errno values
      hurd: Fix accessing errno from rtld
      hurd: Initialize TLS and libpthread before signal thread start
      Add missing changelog from previous commit
      hurd: Fix calling __pthread_initialize_minimal in shared case
      hurd: Regenerate errno.h header
      hurd: advertise process memory locking option
      hurd: avoid letting signals go to thread created by timer_create
      hurd: Add hurd thread library
      hurd libpthread: add function missing in ABI list
      hurd: Advertise libpthread
      hurd: Remove bogus net/if_ppp.h
      hurd: Bump remaining LGPL2+ htl licences to LGPL 2.1+
      hurd: Announce that glibc now builds unpatched
      hurd: Fix exposition of UTIME_NOW, UTIME_OMIT
      hurd: Avoid local PLTs in libpthread.
      hurd: Avoid some PLTs in libc and librt
      Revert __dirfd PLT avoidance for now
      hurd: whitelist rtld symbols expected to be overridable
      hurd: Add __errno_location to overridable ld.so symbols
      hurd: Update localplt.data
      hurd: whitelist ld.so PLTs supposed to be avoided by rtld_hidden
      hurd: Avoid some libc.so PLTs
      hurd: Avoid more libc.so PLTs
      hurd: Fix typo
      hurd: Avoid more libc.so local PLTs
      hurd: Avoid local PLT in libpthread
      s390x: Fix hidden aliases
      hurd: Fix buffer overrun in __if_nametoindex
      Revert "s390x: Fix hidden aliases"
      Revert parts of "hurd: Avoid more libc.so local PLTs"
      hurd: Make __if_nametoindex return ENODEV if ifname is too long
      hurd: Fix missing trailing NUL in __if_nametoindex
      hurd: Silence warning
      hurd: Add missing symbols
      hurd: fix build
      hurd: Fix typo
      hurd: Avoid PLTs for longjmp & siglongjmp
      hurd: Avoid PLT for dirfd
      Revert "hurd: Avoid PLTs for longjmp & siglongjmp"
      hurd: fix conformity test for sys/un.h
      hurd: Fix spurious installation of headers defining hidden prototypes
      Fix sched_param
      conform sys/un.h: Allow sun_ prefix, not only sun_len
      Revert "Fix sched_param"
      hurd: Fix mach installed headers test
      hurd: xfail some structure fields ABI incompatibility with standards
      hurd: Fix standard compliance of some statvfs fields
      hurd: Update struct statfs according to struct statvfs
      hurd: Fix symbols exposition
      hurd: Avoid exposing all <sched.h> symbols from sys/types.h
      hurd: fix sigevent's sigev_notify_attributes field type
      hurd: remove non-standard siginfo symbol
      hurd: Fix termios.h symbols
      hurd: Add missing RLIM_SAVED_MAX/CUR
      hurd: Fix hurd installed headers test
      Drop fpregset unused symbol exposition
      Revert "hurd: Fix mach installed headers test"
      hurd: XFAIL appearance of sched_param and sched_priority from <sys/types.h>
      hurd: XFAIL tests for signal features not implemented yet
      hurd xfails: Add missing bug references
      hurd: Fix shmid_ds's shm_segsz field type
      hurd: xfail missing abilist for libmachuser and libhurduser
      hurd: update localplt.data
      hurd: Avoid PLTs for _hurd_port_locked_get/set
      hurd: Avoid PLTs for __mach_thread_self and __mach_reply_port
      hurd: Avoid a PLT reference
      hurd: Fix htl link failure
      hurd: avoid PLT ref between sendfile and sendfile64
      hurd: Detect 32bit overflow in value returned by lseek
      hurd: Avoid PLT ref for __pthread_get_cleanup_stack
      hurd: Avoid missing PLT ref from ld.so requirement
      hurd: Avoid PLT references to shortcuts
      hurd: Avoid PLT ref to __mach_msg
      hurd: Avoid PLT references to syscalls
      hurd: Whitelist PLT refs which are difficult to avoid
      hurd: Fix missing __pthread_get_cleanup_stack symbol
      hurd: Fix reference to _hurd_self_sigstate
      hurd: Fix "Missing required PLT reference"
      hurd: fix localplt.data format
      hurd: Enable thread-safe i386 atomic instructions
      Fix new file header
      hurd: Fix installed-headers tests
      check-execstack: Permit sysdeps to xfail some libs
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix startup of static binaries linked against libpthread
      hurd: Add missing ChangeLog entry
      hurd: Fix exec usage of mach_setup_thread

Sean McKean (1):
      time: Reference CLOCKS_PER_SEC in clock comment [BZ #22735]

Siddhesh Poyarekar (18):
      benchtests: Reallocate buffers for every test run
      benchtests: Make bench-memcmp print json
      aarch64: Use the L() macro for labels in memcmp
      aarch64/strcmp: fix misaligned loop jump target
      benchtests: Convert strncmp benchmark output to json
      benchtests: Reallocate buffers for every strncmp implementation
      benchtests: Don't benchmark 0 length calls for strncmp
      Add ChangeLog entry for last 3 commits
      aarch64: Optimized memcmp for medium to large sizes
      aarch64: Fix branch target to loop16
      aarch64: Improve strncmp for mutually misaligned inputs
      aarch64/strncmp: Unbreak builds with old binutils
      aarch64/strncmp: Use lsr instead of mov+lsr
      benchtests: Move iterator declaration into loop header
      aarch64,falkor: Ignore prefetcher hints for memmove tail
      aarch64,falkor: Ignore prefetcher tagging for smaller copies
      aarch64,falkor: Use vector registers for memmove
      aarch64,falkor: Use vector registers for memcpy

Stefan Liebler (9):
      S390: Regenerate ULPs.
      Add runtime check if mutex will be elided in tst-mutex8 testcases.
      S390: Regenerate ULPs.
      S390: Regenerate ULPs.
      S390: Fix struct sigaction for 31bit in kernel_sigaction.h.
      Use volatile global counters in test-tgmath.c.
      Disable lock elision for mutex pretty printer tests.
      Fix blocking pthread_join. [BZ #23137]
      Fix string/tst-xbzero-opt if build with gcc head.

Steve Ellcey (2):
      IFUNC for Cavium ThunderX2
      aarch64: Use an ifunc/VDSO to implement gettimeofday in shared glibc.

Sylvain Lesage (1):
      es_BO locale: Change LC_PAPER to en_US (bug 22996).

Szabolcs Nagy (5):
      Remove slow paths from exp
      Fix documentation build with old makeinfo
      Use uint32_t sign in single precision math error handling functions
      aarch64: Remove HWCAP_CPUID from HWCAP_IMPORTANT
      aarch64: add HWCAP_ATOMICS to HWCAP_IMPORTANT

Thomas Schwinge (3):
      hurd: SOCK_CLOEXEC and SOCK_NONBLOCK for socket
      hurd: SOCK_CLOEXEC and SOCK_NONBLOCK for socketpair
      hurd: Implement pipe2

Tulio Magno Quites Machado Filho (14):
      powerpc: Update pow() ULPs
      powerpc: Undefine Linux ptrace macros that conflict with __ptrace_request
      powerpc: Update sin, cos and sincos ULPs
      Increase robustness of internal dlopen() by using RTLD_NOW [BZ #22766]
      Replace M_SUF (fabs) with M_FABS
      Replace M_SUF (M_LN2) with M_MLIT (M_LN2)
      Replace hidden_def with libm_hidden_def in math
      powerpc: Fix the compiler type used with C++ when -mabi=ieeelongdouble
      powerpc: Move around math-related Implies
      powerpc64le: Fix TFtype in sqrtf128 when using -mabi=ieeelongdouble
      Move declare_mgen_finite_alias definition
      Add a generic significand implementation
      ldbl-128ibm-compat: Create libm-alias-float128.h
      m68k: Reorganize log1p and significand implementations

Valery Timiriliyev (1):
      New locale: Yakut (Sakha) for Russia (sah_RU) [BZ #22241]

Vincent Chen (1):
      Add Andes nds32 dynamic relocations to elf.h

Wilco Dijkstra (20):
      Remove slow paths from log
      [AArch64] Use builtins for fpcr/fpsr
      [AArch64] Fix testsuite error due to fpsr/fscr change
      Remove slow paths from pow
      Remove mplog and mpexp
      [AArch64] Fix include.
      Use correct includes in benchtests
      Add support for sqrt asm redirects
      Rename all __ieee754_sqrt(f/l) calls to sqrt(f/l)
      Remove all target specific __ieee754_sqrt(f/l) inlines
      Revert m68k __ieee754_sqrt change
      Undefine attribute_hidden to fix benchtests
      sin/cos slow paths: avoid slow paths for small inputs
      sin/cos slow paths: remove large range reduction
      sin/cos slow paths: remove slow paths from small range reduction
      sin/cos slow paths: remove slow paths from huge range reduction
      sin/cos slow paths: remove unused slowpath functions
      sin/cos slow paths: refactor duplicated code into dosin
      sin/cos slow paths: refactor sincos implementation
      Improve strstr performance

Zack Weinberg (23):
      Remove some unnecessary redefinitions of std symbols.
      Remove getc and putc macros from the public stdio.h.
      Don't install libio.h or _G_config.h.
      Post-cleanup 1: move libio.h back out of bits/.
      Post-cleanup 2: minimize _G_config.h.
      [BZ #22830] malloc_stats: restore cancellation for stderr correctly.
      [BZ #19239] Don't include sys/sysmacros.h from sys/types.h.
      Remove vestiges of external build support from libio headers.
      Mechanically remove _IO_ name aliases for types and constants.
      Remove legacy configuration knobs from libio.
      Remove _IO_file_flags define.
      Remove miscellaneous debris from libio.
      alpha/clone.S: Invoke .set noat/.set at around explicit uses of $at
      Don't include math.h/math_private.h in math_ldbl_opt.h.
      nldbl-compat.c: Include math.h before nldbl-compat.h.
      [BZ 1190] Make EOF sticky in stdio.
      Make sysdeps/generic/internal-signals.h less stubby.
      NEWS: Reindent and copyedit
      Avoid cancellable I/O primitives in ld.so.
      Disallow use of DES encryption functions in new programs.
      manual: Reorganize crypt.texi.
      manual: Revise crypt.texi.
      New configure option --disable-crypt.

Zong Li (1):
      Change URL of gcc's tarball

-----------------------------------------------------------------------